// $Id: JABngAway_Main.java,v 1.1.1.1 1998/07/29 12:38:16 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/clients/Jabngaway/JABngAway_Main.java,v $
//
// $Log: JABngAway_Main.java,v $
// Revision 1.1.1.1  1998/07/29 12:38:16  mencnar
// initial revision
//
//
// Author: Daniel Mencnarowski (mencnar@ics.agh.edu.pl)
//
// Description: ABng away client implementation
//

package pl.edu.agh.ics.abngcore;

import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;
import java.util.Vector;

class MyTable extends AbstractTableModel {
  MyAway []aways= new MyAway[0];
  Vector all_aways= new Vector();
  private int criteria_item_id= 0;

  private static String[] col_names = {
    "active",
    "user_id",
    "forename",
    "surname",
    "from",
    "to",
    "message",
    "contact",
    "badge cancels"
  };

  public MyTable() {
    aways= new MyAway[0];
  }

  public int getColumnCount() { 
    return col_names.length; 
  }

  public synchronized int getRowCount() {
    return aways.length;
  }

  public synchronized MyAway getRowData( int row) {
    if (row<0 || row>=getRowCount()) return null;
    return aways[row];
  }

  public synchronized Object getValueAt(int row, int col) {
    if (row<0 || row>=getRowCount()) return null;

    switch (col) {
    case 0: // Active flag
      return new Boolean( aways[row].away_descr.active);
    case 1:
      return aways[row].away_descr.type_specific_object_value.user_description().uid;
    case 2:
      return aways[row].away_descr.type_specific_object_value.user_description().forename;
    case 3:
      return aways[row].away_descr.type_specific_object_value.user_description().surname;
    case 4:
      return getString( aways[row].away_descr.start_time);
    case 5:
      return getString( aways[row].away_descr.stop_time);
    case 6:
      return aways[row].away_descr.message;
    case 7:
      return aways[row].away_descr.contact;
    case 8: // Badge cancels ?
      return new Boolean( aways[row].away_descr.cancel_by_badge);
    default:
      return "";
    }
  }
  
  private static String getString( Domain_Repository.Time tm) {
    return (new java.util.Date( ((long) tm.seconds)*1000)).toString();
  }

  synchronized void updateData( MyAway []mas) {
    all_aways.removeAllElements();
    int size= 0;
    for (int i=0; i<mas.length; i++) {
      all_aways.addElement( mas[i]);
      if (checkCriteria( mas[i])) size++;
    }
    aways= new MyAway[size];
    int k=0;
    for (int i=0; i<mas.length; i++)
      if (checkCriteria( mas[i])) aways[k++]= mas[i];
    sort();
    System.err.println("updateData "+size);
    fireTableDataChanged();
  }

  private void internalUpdateData( MyAway ma_added,
				   MyAway ma_updated,
				   MyAway ma_removed,
				   boolean reorganise) {
    if ( checkCriteria( ma_added) ||
	 checkCriteria( ma_updated) ||
	 checkCriteria( ma_removed) ||
	 reorganise) {
      
      int size= 0;
      for (int i=0; i<all_aways.size(); i++) 
	if (checkCriteria( (MyAway) all_aways.elementAt(i))) size++;
      // System.err.println( ""+size+" items matched criteria");
      int del_item= -1;
      if (ma_removed != null) del_item= getAwayIndex( ma_removed);
	
      aways= new MyAway[size];
      size= 0;
      for (int i=0; i<all_aways.size(); i++)
	if (checkCriteria( (MyAway) all_aways.elementAt(i)))
	  aways[size++]= (MyAway) all_aways.elementAt(i);
      sort();
      if (ma_removed != null) {
	fireTableDataChanged();
	return;
	/*
	if (del_item<0) return;
	fireTableRowsDeleted( del_item, del_item);
	*/
      }
      if (ma_added != null) {
	fireTableDataChanged();
	return;
	/*
	int index= getAwayIndex(ma_added);
	if (index<0) return;
	fireTableRowsInserted( index, index);
	*/
      }
      if (ma_updated != null) {
	fireTableDataChanged();
	return;
	/*
	int index= getAwayIndex(ma_updated);
	if (index<0) return;
	fireTableRowsUpdated( index, index);
	*/
      }
    }
  }

  private int getAwayIndex( MyAway ma) {
    for (int i=0; i<aways.length; i++)
      if (aways[i] == ma) return i;
    return -1;
  }

  private boolean checkCriteria( MyAway away) {
    if (away == null) return false;
    if (criteria_item_id == 0) return true;
    try {
      return (away.away_descr.type_specific_object_value.user_description().item_id == criteria_item_id);
    }
    catch (Exception ex) {}
    return false;
  }

  public synchronized void setCriteria( int user_item_id) {
    criteria_item_id= user_item_id;
    //    System.err.println("setCriteria "+criteria_item_id);
    internalUpdateData( null, null, null, true);
    fireTableDataChanged();
  }

  private void sort() {}

  public String getColumnName(int column) {
    if (column>=0 && column<col_names.length) return col_names[column];
    else return "";
  }

  public Class getColumnClass(int c) {
    switch (c) {
    case 0:
    case 8:// Active flag, badge cancels
      return (new Boolean(false)).getClass();
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
      return ("".getClass());

    default: return ("".getClass());
    }
  }

  public boolean isCellEditable(int row, int col) {return false; }

  public synchronized void addItem( ABng_Core.Away away_ref,
		       ABng_Core.AwayPackage.Value_Description away_descr) {

    MyAway ma;
    all_aways.addElement( ma= new MyAway( away_ref, away_descr));
    internalUpdateData( ma, null, null, false);
  }

  public synchronized void updateItem( ABng_Core.Away away_ref,
			  ABng_Core.AwayPackage.Value_Description away_descr) {

    System.err.println( away_descr.item_id);
    for (int i=0; i<all_aways.size(); i++)
      if ( ((MyAway) all_aways.elementAt(i)).away_descr.item_id ==
	   away_descr.item_id) {
	MyAway ma= (MyAway) all_aways.elementAt(i);
	ma.away_descr= away_descr;
	System.err.println( ma.away_descr);
	internalUpdateData( null, ma, null, false);	
      }
  }

  public synchronized void deleteItem( int item_id) {
    for ( int i=0; i<all_aways.size(); i++)
      if ( ((MyAway) all_aways.elementAt( i)).away_descr.item_id == item_id) {
	MyAway ma= (MyAway) all_aways.elementAt(i);
	all_aways.removeElementAt( i);
	internalUpdateData( null, null, ma, false);
      }
  }
};

public class JABngAway_Main extends JPanel 
                            implements Bootstrap_listener_interface_n,
                                       ABng_Core._Away_Data_ObserverOperations,
                                       ListSelectionListener,
                                       ActionListener
{
  static JFrame frame;
  static ORB_wrapper my_orb_wrapper;

  JDialog option_dialog;
  JTable tableView;
  JScrollPane tablePane;
  JABngAway_Form formPane;
  MyTable dataModel;
  JPanel selectPanel;
  JABng_Locatable_User selectUser;
  JButton list_button, list_all_button;

  ABng_Core_Management.Away_Rep_Manager away_manager= null;
  ABng_Core.Away_Rep away_rep= null;
  private Bootstrap_listener_n bootstrap_listener= null;
  private ABng_Core.Away_Data_Observer away_observer_object= null;
  private int user_sort_mode= JABng_Locatable_User.JLU_SORT_FIRST;

  public JABngAway_Main() {
    away_observer_object= new ABng_Core._tie_Away_Data_Observer( this);
    my_orb_wrapper.connect_object( away_observer_object);

    setLayout(new BorderLayout());

    add( selectPanel= new JPanel(), BorderLayout.NORTH);
    selectPanel.add( selectUser= new JABng_Locatable_User());
    selectPanel.add( list_button= new JButton("List"));
    list_button.addActionListener( this);
    selectPanel.add( list_all_button= new JButton("List all"));
    list_all_button.addActionListener( this);
    add( tablePane= createTable(), BorderLayout.CENTER);
    add( formPane= new JABngAway_Form(this), BorderLayout.SOUTH);
    try {
      bootstrap_listener= new Bootstrap_listener_n( this);

      away_rep= ABng_Core.Away_RepHelper.narrow
	(Bootstrap_n.resolve( Bootstrap_n.SRV_Away_Repository()));

      away_manager= ABng_Core_Management.Away_Rep_ManagerHelper.narrow
	(Bootstrap_n.resolve( Bootstrap_n.SRV_Away_Repository_Manager()));

      bootstrap_listener.register_callback( Bootstrap_n.SRV_Away_Repository());

      bootstrap_listener.register_callback(
	     Bootstrap_n.SRV_Away_Repository_Manager());
    }
    catch (Exception ex) {
      System.err.println("Error contacting Server Manager / Away Repository");
      System.err.println( ex);
      System.exit(1);
    }
  }

  public synchronized void reference_resolved( String[] name,
					       org.omg.CORBA.Object server_ref,
					       int callback_identifier) {

    System.err.println("reference_resolved");
    if ( Bootstrap_n.equal_names
	 ( name, Bootstrap_n.SRV_Away_Repository())) {

      away_rep= ABng_Core.Away_RepHelper.narrow( server_ref);
      loadData();
    }
    if ( Bootstrap_n.equal_names
      (name, Bootstrap_n.SRV_Away_Repository_Manager())) {

      away_manager= ABng_Core_Management.Away_Rep_ManagerHelper.narrow
	(server_ref);
    } 
  }

  public void server_shutdown( String[] name,
			     int callback_identifier) {}

  public void _notify( int item_id, 
		      ABng_Core.Away_Data_ObserverPackage.Away_Data_Object ado,
		      Domain_Repository.Change_Type ct) {
    notify( item_id, ado, ct);
  }

  public void notify( int item_id, 
		      ABng_Core.Away_Data_ObserverPackage.Away_Data_Object ado,
		      Domain_Repository.Change_Type ct) {

    switch (ct.value()) {
    case Domain_Repository.Change_Type._OBJECT_ADDED:
      try {
	ado.away_obj.attach_away_data_observer( away_observer_object);
	dataModel.addItem( ado.away_obj,
			   ado.away_obj.value_descr());
      }
      catch (Exception ex) {}
      break;
    case Domain_Repository.Change_Type._OBJECT_UPDATED:
      System.err.println("UPDATED");
      try {
	dataModel.updateItem( ado.away_obj,
			      ado.away_obj.value_descr());
      }
      catch (Exception ex) {
	System.err.println( ex.toString());
      }
      break;
    case Domain_Repository.Change_Type._OBJECT_REMOVED:
      System.err.println("REMOVED");
      dataModel.deleteItem( item_id);
      break;
    }
  }

  public void abort() {}

  private void showOptions() {
    createDialog();
    option_dialog.show();
  }

  public synchronized void actionPerformed( ActionEvent e) {
    Object source= e.getSource();
    
    if (source == list_button) {
      int id= selectUser.getUserItemId();
      if (id != 0) dataModel.setCriteria( id);
    }
    else if ( source == list_all_button) {
      dataModel.setCriteria( 0);
    }
    else {
      String ac= e.getActionCommand();
      if ("Refresh".equals(ac)) {
	loadData();
	selectUser.loadData();
      }
      else if ("Exit".equals(ac)) System.exit(0);
      else if ("Options".equals(ac)) showOptions();
    }
  }

  private void loadData() {
    System.err.println( "loadData");
    try {
      ABng_Core.AwayPackage.Pattern patt=
	RepTools.get_arep_pattern();

      ABng_Core.AwayPackage.Entity_Set es=
	new ABng_Core.AwayPackage.Entity_Set();
      es.s_pattern( patt);

      Domain_Repository.Query_Options qo=
	new Domain_Repository.Query_Options();
      qo.return_references= true;
      qo.return_descriptions= true;
      qo.return_value_descriptions= true;
      qo.do_attach= true;
      qo.do_detach= false;

      ABng_Core.AwayPackage.Query_Results qr=
	away_rep.complex_query( es, qo, away_observer_object);
      away_rep.attach_add_away_data_observer( away_observer_object);
      int len= qr.r_references.length;
      MyAway []mas= new MyAway[len];
      for (int i=0; i<len; i++) {
	qr.r_value_descriptions[i].item_id=
	  qr.r_descriptions[i].item_id;
	mas[i]= new MyAway( qr.r_references[i],
			    qr.r_value_descriptions[i]);
      }
      dataModel.updateData( mas);
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public void valueChanged( ListSelectionEvent e) {
    int sels[]= tableView.getSelectedRows();
    if (sels.length == 1) formPane.setData( dataModel.getRowData( sels[0]));
    //    else formPane.setData( null);
  }

  JScrollPane createTable() {
    // Create a model of the data.
    dataModel = new MyTable();
   
    tableView= new JTable(dataModel);
    tableView.getSelectionModel().addListSelectionListener( this);
    return JTable.createScrollPaneForTable(tableView);
  }

  void createDialog() {
    if (option_dialog == null) {
      option_dialog= new JDialog( frame, "Options", true);
      option_dialog.getContentPane().setLayout( new BorderLayout());
      final JRadioButton rb[]= {
	new JRadioButton("user id"),
	new JRadioButton("forename"),
	new JRadioButton("surname") 
      };

      ButtonGroup bg= new ButtonGroup();
      bg.add( rb[0]);
      bg.add( rb[1]);
      bg.add( rb[2]);

      for (int i=0; i<=2; i++)
	rb[i].setSelected( (i==user_sort_mode));

      JOptionPane opt_panel= 
	new JOptionPane( "Choose user by",
			 JOptionPane.QUESTION_MESSAGE,
			 JOptionPane.OK_CANCEL_OPTION,
			 null,
			 rb);;
      option_dialog.getContentPane().add( opt_panel,
					  BorderLayout.NORTH);
      JPanel button_panel;
      option_dialog.getContentPane().add( button_panel= new JPanel(),
					  BorderLayout.SOUTH);
      final JButton ok_button, cancel_button;
      button_panel.add( ok_button= new JButton("OK"));
      button_panel.add( cancel_button= new JButton("Cancel"));
      ActionListener al= new ActionListener() {
	public void actionPerformed( ActionEvent e) {
	  Object source= e.getSource();

	  if (source == ok_button) {
	    for (int i=0; i<=2; i++)
	      if (rb[i].isSelected()) {
		selectUser.setSortOrder( i);
		formPane.setUserSortOrder( i);
	      }
	  }
	  option_dialog.hide();
	}
      };
      ok_button.addActionListener( al);
      cancel_button.addActionListener( al);
      option_dialog.pack();
    }
    option_dialog.setLocation( frame.getLocation());
  }

  JMenuBar createMenuBar() {
    JMenuBar mb= new JMenuBar();
    JMenu menu= new JMenu("Misc");
    mb.add( menu);
    JMenuItem mi;
    menu.add( mi= new JMenuItem("Options"));
    mi.setActionCommand("Options");
    mi.addActionListener(this);
    menu.add( mi= new JMenuItem("Refresh"));
    mi.setActionCommand("Refresh");
    mi.addActionListener(this);
    menu.addSeparator();
    menu.add( mi= new JMenuItem("Exit"));
    mi.setActionCommand("Exit");
    mi.addActionListener(this);

    return mb;
  }

  public static void main(String argv[]) {
    my_orb_wrapper= new ORB_wrapper();
    my_orb_wrapper.init_application( argv);
    Bootstrap_n.init();

    JABngAway_Main panel= new JABngAway_Main();
    frame = new JFrame("ABng away messages");
    frame.setJMenuBar( panel.createMenuBar());
    frame.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {System.exit(0);}
    });
    frame.getContentPane().add("Center", panel);
    frame.setSize(800,540);
    frame.show();
    frame.validate();
    frame.repaint();
  }

};
