// $Id: JABng_Calendar.java,v 1.1.1.1 1998/07/29 12:38:16 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/clients/Jabngaway/JABng_Calendar.java,v $
//
// $Log: JABng_Calendar.java,v $
// Revision 1.1.1.1  1998/07/29 12:38:16  mencnar
// initial revision
//
//
// Author: Daniel Mencnarowski (mencnar@ics.agh.edu.pl)
//

package pl.edu.agh.ics.abngcore;

import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;

import java.util.Date;
import java.util.Calendar;
import java.text.DateFormat;

public class JABng_Calendar extends JPanel {
  private Date my_date;
  private Calendar my_calendar= Calendar.getInstance();
  private JTextField year_field;
  private JComboBox month_combo;
  private JTextField day_field;
  private JTextField hour_field, minute_field, second_field;

  private static String []month_names= {
    "Jan", "Feb", "Mar", "Apr", "May", "Jun",
    "Jul", "Aug", "Sep", "Oct", "Nov", "Dec      "
  };

  public void change_date( Date new_date) {
    my_date= new_date;
    my_calendar.setTime( my_date);
    year_field.setText( ""+my_calendar.get( Calendar.YEAR));
    month_combo.setSelectedItem( month_names[ my_calendar.get( Calendar.MONTH)]);
    day_field.setText( ""+my_calendar.get( Calendar.DAY_OF_MONTH));
    hour_field.setText( ""+my_calendar.get( Calendar.HOUR_OF_DAY));
    minute_field.setText( ""+my_calendar.get( Calendar.MINUTE));
    second_field.setText( ""+my_calendar.get( Calendar.SECOND));
  }

  private void init( Date new_date) {
    add( year_field= new JTextField( 4));
    year_field.setHorizontalAlignment( JTextField.RIGHT);
    add( month_combo= new JComboBox( month_names));
    add( day_field= new JTextField( 2));
    day_field.setHorizontalAlignment( JTextField.RIGHT);
    add( Box.createHorizontalStrut( 15));
    add( hour_field= new JTextField( 2));
    hour_field.setHorizontalAlignment( JTextField.RIGHT);
    add( new JLabel(":"));
    add( minute_field= new JTextField( 2));
    minute_field.setHorizontalAlignment( JTextField.RIGHT);
    add( new JLabel(":"));
    add( second_field= new JTextField( 2));
    second_field.setHorizontalAlignment( JTextField.RIGHT);
    change_date( new_date);
  }

  public JABng_Calendar( Date new_date) {
    init( new_date);
  }

  public JABng_Calendar() {
    init( new Date());
  }

  public void setEnabled( boolean flag) {
    super.setEnabled( flag);
    year_field.setEnabled( flag);
    month_combo.setEnabled( flag);
    day_field.setEnabled( flag);
    hour_field.setEnabled( flag);
    minute_field.setEnabled( flag);
    second_field.setEnabled( flag);
  }

  public Domain_Repository.Time getTimeObject() {
    Date new_date;
    try {
      new_date= 
	new Date( Integer.valueOf( year_field.getText()).intValue()-1900,
		  month_combo.getSelectedIndex(),
		  Integer.valueOf( day_field.getText()).intValue(),
		  Integer.valueOf( hour_field.getText()).intValue(),
		  Integer.valueOf( minute_field.getText()).intValue());
    }
    catch (Exception ex) {
      throw new NumberFormatException("Ill formated date");
    }

    Domain_Repository.Time ret= new Domain_Repository.Time();
    ret.seconds= (int) (new_date.getTime() / 1000);
    ret.microseconds= 0;
    return ret;
  }
}




