package ABngSystem;
 
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;
 
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
 
import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;
 
//////////////////////////////////////////////////
/* This class represents a graphic "part" of itch location type
   It just shows badge's fields to user.
   Few methods to manage this fields */
///////////////////////////////////////
 
class AbngldPanel extends ItemPanel{
 
   boolean state;
   int type;
   int index;
   Window parent;
   org.omg.CORBA.Object object;
   Domain_Repository.Location_Description locdesc;   
   RepGet repository;
 
   JButton ldesc;
   JList proplist;
   JButton propbutton;
   JButton add;
   JButton remove;
   String[] sensornames;
   Sensor[] sensors;

   Domain_Repository.Location_DescriptionPackage.Pattern locpattern;
   ABng_Core_System.SensorPackage.Pattern[] sensorpattern;

   public AbngldPanel(boolean state, int type, Window parent){
 
      JPanel pane = new JPanel();
      pane.setLayout(null);
      this.state = state;
      this.type = type;
      this.parent = parent;
      object = null;
      index = -1;
      repository = new RepGet();
      repository.init(RepName.abngldRep);
 
      sensornames = new String[0];
      sensors = new Sensor[0];
 
      JLabel label;
      label = new JLabel("Location_Description:");
      label.setSize(330,15);
      label.setLocation(10,10);
      pane.add(label);

      AbngldClicked hc = new AbngldClicked();
      ldesc = new JButton("< EMPTY >");
      ldesc.setSize(315,20);
      ldesc.setLocation(25,30);
      ldesc.setEnabled(state);
      ldesc.addActionListener(hc);
      pane.add(ldesc);
      locdesc = null;
      ldesc.setText(RepGet.DescriptABngLocationDescription(locdesc));
 
      label = new JLabel("Sensor list:");
      label.setSize(330,15);
      label.setLocation(10,60);
      pane.add(label);
      proplist = new JList(sensornames);
      proplist.setLocation(0,0);
      proplist.addListSelectionListener(new ItemChanged());
      JScrollPane scrollpane = new JScrollPane(proplist);
      scrollpane.setSize(315,150);
      scrollpane.setLocation(25,80);
      pane.add(scrollpane);

      AbngldClicked ldc = new AbngldClicked();
      propbutton = new JButton("Display selected sensor");
      propbutton.setSize(315,20);
      propbutton.setLocation(25,240);
      propbutton.setEnabled(false);
      propbutton.addActionListener(ldc);
      pane.add(propbutton);
      
      add = new JButton("Add sensor");
      add.setSize(150, 20);
      add.setLocation(25, 270);
      add.setEnabled(state);
      add.addActionListener(ldc);
      pane.add(add);
      remove = new JButton("Remove sensor");
      remove.setSize(150, 20);
      remove.setLocation(190, 270);
      remove.setEnabled(false);
      remove.addActionListener(ldc);
      pane.add(remove);
 
      if (type == 2){
         add.setText("Add Sensor Pattern");
         remove.setText("Remove Sensor Pattern");
         ldesc.setText("Location Description Pattern");
      }
 
//      locpattern = RepGet.BuildLocationDescriptionPattern("", "", RepGet.BuildPropertiesPattern(null, new Domain_Repository.Propertiey_Pattern[0]));
      sensorpattern = new ABng_Core_System.SensorPackage.Pattern[0];
      pane.setPreferredSize(new Dimension(360,300));
      add(pane);
      this.setViewportView(pane);
   }
 
// Get itch of the fields
   public Domain_Repository.Location_Description getLocationDescription() { return locdesc; }
   public Sensor[] getSensors() { return sensors; }
 
// Set itch of the fields
   public void setLocationDescription(Domain_Repository.Location_Description value) { 
      locdesc = value;
      ldesc.setText(RepGet.DescriptLocationDescription(locdesc));
   }
   public void setSensors(Sensor[] value) { sensors = value; }
 
// Clear all fields
   public void clear(){
      locdesc = null;
      ldesc.setText(RepGet.DescriptLocationDescription(locdesc));
      if (type == 2) ldesc.setText("Location Description Pattern");
      sensors = new Sensor[0];
      sensornames = new String[0];
      proplist.setListData(sensornames);
      proplist.repaint();
      proplist.revalidate();
   }
 
// Chack if all filds are filled
   public boolean check(){
      if (locdesc == null) return false;
      return true;
   }
 
// Just copy the content of source badge
   public void copy(ItemPanel source){
   }
 
   public void setData(org.omg.CORBA.Object source){
 
      ABng_Core_System.ABng_Location_Description ld = ABng_Core_System.ABng_Location_DescriptionHelper.narrow(source);
      object = source;

      try{
         locdesc = ld.loc_descr();
         if (locdesc == null) {
            ldesc.setEnabled(state);
         } else {
            ldesc.setEnabled(true);
         }
      } catch (Exception e){
         locdesc = null;
         ldesc.setEnabled(state);
      }
      ldesc.setText(RepGet.DescriptLocationDescription(locdesc));

      RGContainer rg = repository.ABLDlist(ld);
      if (rg.IsError())
         JOptionPane.showMessageDialog(parent, rg.GetErrorText(), "Sensor List Error", JOptionPane.ERROR_MESSAGE);
      try{
         sensors = ld.sensor_list();
         if (sensors == null) {
            sensors = new Sensor[0];
         }
      } catch (Exception e){
         sensors = new Sensor[0];
      }
      sensornames = rg.GetStrings();
      proplist.setListData(sensornames);
      proplist.repaint();
      proplist.revalidate();
      propbutton.setEnabled(false);
      remove.setEnabled(false);
      repaint();
   }
 
// Build pattern for find function
 
   public ABng_Core_System.ABng_Location_DescriptionPackage.Pattern buildPattern(){
      ABng_Core_System.SensorPackage.Sensors_Pattern spattern = RepGet.BuildSensorsPattern(null, sensorpattern);
      return RepGet.BuildABngLocationDescriptionPattern( "", locpattern, spattern);
   }
 
/////////////////////////////////
/* Reaction for button clicked */
/////////////////////////////////
 
   protected final class AbngldClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == propbutton){
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            ViewDialog dlg = new ViewDialog(parent, RepName.sensorRep, sensors[index]);
            if (dlg.getAnswer()){
               sensors[index] = SensorHelper.narrow(dlg.getObject());
               repository.update(object, getLocationDescription(), getSensors());
               setData(object);
            }
            dlg.dispose();
         } 
         else if (((JButton) e.getSource()) == add){
            if (type == 1){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               RepositoryReferenceDialog dlg;
               dlg = new RepositoryReferenceDialog(parent, RepName.sensorRep);
               if (dlg.getAnswer()){
                  Sensor sensor = SensorHelper.narrow(dlg.getObject());
                  if (object == null) {
                     parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                     int count = sensors.length;
                     Sensor[] old = sensors;
                     String[] oldnames = sensornames;
                     sensors = new Sensor[count+1];
                     sensornames = new String[count+1];
                     for (int i=0; i<count; i++){
                        sensors[i] = old[i];
                        sensornames[i] = oldnames[i];
                     }
                     sensors[count] = sensor;
                     sensornames[count] = RepGet.DescriptSensor(sensor);
                        proplist.setListData(sensornames);
                     proplist.repaint();
                     proplist.revalidate();
                  } else {
                     parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                     String mesg = repository.ABLDadd(object, sensor);
                     if (mesg.equals("OK"))
                        setData(object);
                     else 
                        JOptionPane.showMessageDialog(parent, mesg, "Can't add sensor", JOptionPane.ERROR_MESSAGE);
                  }
               }
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               FindDialog dlg = new FindDialog(parent, RepName.sensorRep);
               if (dlg.getAnswer()){
                  int count = sensorpattern.length;
                  ABng_Core_System.SensorPackage.Pattern[] old = sensorpattern;
                  String[] oldnames = sensornames;
                  sensorpattern = new ABng_Core_System.SensorPackage.Pattern[count+1]; 
                  sensornames = new String[count+1];
                  for (int i=0; i<count; i++){
                     sensorpattern[i] = old[i];
                     sensornames[i] = oldnames[i];
                  }
                  sensorpattern[count] = ((SensorPanel) dlg.getPanel()).buildPattern();
                  sensornames[count] = "Sensor Pattern";
                  proplist.setListData(sensornames);
                  proplist.repaint();
                  proplist.revalidate();
               }
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
         }
         else if (((JButton) e.getSource()) == remove){
            if (type == 1) {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               if (object == null) {
                  int count = sensors.length;
                  for (int i=index; i<count-1; i++){
                     sensors[i] = sensors[i+1];
                     sensornames[i] = sensornames[i+1];
                  }
                  sensors[count-1] = null;
                  sensornames[count-1] = null;
                  Sensor[] old = sensors;
                  String[] oldnames = sensornames;
                  sensors = new Sensor[count-1];
                  sensornames = new String[count-1];
                  for (int i=0; i<count-1; i++){
                     sensors[i] = old[i];
                     sensornames[i] = oldnames[i];
                  }
                  proplist.setListData(sensornames);
                  proplist.repaint();
                  proplist.revalidate();
               } else {
                  String mesg = repository.ABLDremove(object, sensors[index]);
                  if (mesg.equals("OK"))
                     setData(object);
                  else 
                     JOptionPane.showMessageDialog(parent, mesg, "Can't remove sensor", JOptionPane.ERROR_MESSAGE);
               }
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2) {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               int count = sensorpattern.length;
               for (int i=index; i<count-1; i++){
                  sensorpattern[i] = sensorpattern[i+1];
                  sensornames[i] = sensornames[i+1];
               }
               sensorpattern[count-1] = null;
               sensornames[count-1] = null;
               ABng_Core_System.SensorPackage.Pattern[] old = sensorpattern;
               String[] oldnames = sensornames;
               sensorpattern = new ABng_Core_System.SensorPackage.Pattern[count-1];
               sensornames = new String[count-1];
               for (int i=0; i<count-1; i++){
                  sensorpattern[i] = old[i];
                  sensornames[i] = oldnames[i];
               }
               proplist.setListData(sensornames);
               proplist.repaint();
               proplist.revalidate();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
            remove.setEnabled(false);
            propbutton.setEnabled(false);
         }
         else if (((JButton) e.getSource()) == ldesc){
            if (type == 0){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               ViewDialog dlg = new ViewDialog(parent, RepName.locationDescRep, locdesc);
               if (dlg.getAnswer()){
                  repository.update(object, dlg.getObject(), getSensors());
                  setData(object);
               }
               dlg.dispose();
            } else if (type == 1){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               RepositoryReferenceDialog dlg = null;
               if (locdesc == null)
                  dlg = new RepositoryReferenceDialog(parent, RepName.locationDescRep);
               else dlg =  new RepositoryReferenceDialog(parent, RepName.holderRep, locdesc.item_id());
               if (dlg.getAnswer()){
                  locdesc = Domain_Repository.Location_DescriptionHelper.narrow(dlg.getObject());
                  if (locdesc == null) {
                     ldesc.setEnabled(false);
                  } else {
                     ldesc.setEnabled(true);
                  }
                  ldesc.setText(RepGet.DescriptLocationDescription(locdesc));
               }
               dlg.dispose();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2){
               FindDialog dlg = new FindDialog(parent, RepName.locationDescRep);
               if (dlg.getAnswer()){
               }
            }
         }
      }
   }

//////////////////////////////////////
/* This class response when the user
   click on an item */
//////////////////////////////////////
 
   protected final class ItemChanged implements ListSelectionListener{
      public void valueChanged(ListSelectionEvent e){
         index = proplist.getSelectedIndex();
         if (index!=-1){
            if (type != 2) propbutton.setEnabled(true);
            if (state) remove.setEnabled(true);
         }
      }
   }
 
}
 

