package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;

import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

//////////////////////////////////////////////////
/* This class represents a graphic "part" of each badge
   It just shows badge's fields to user. 
   Few methods to manage this fields */
///////////////////////////////////////

class BadgePanel extends ItemPanel{

   JTextField badgeid;
   JButton holder;
   _Badge_Holder badgeholder;
   boolean state;
   int type;
   Window parent;
   org.omg.CORBA.Object object;

   public BadgePanel(boolean state, int type, Window parent){

      JPanel pane = new JPanel();
      pane.setLayout(null);
      this.state = state;
      this.type = type;
      this.parent = parent;
      object = null;

      JLabel label;
      label = new JLabel("Badge identication number:");
      label.setSize(330,15);
      label.setLocation(10,10);
      pane.add(label);

      badgeid = new JTextField();
      badgeid.setSize(315,20);
      badgeid.setLocation(25,30);
      badgeid.setEnabled(state);
      pane.add(badgeid);

      holder = new JButton("< EMPTY >");
      holder.setSize(315,20);
      holder.setLocation(25,80);
      holder.setEnabled(state);
      if (type != 2){
         label = new JLabel("Badge holder reference:");
         label.setSize(330,15);
         label.setLocation(10,60);
         pane.add(label);
         holder.addActionListener(new BadgeClicked());
         pane.add(holder);
      }
      badgeholder = null;
      holder.setText(RepGet.DescriptBadgeHolder(badgeholder));

      pane.setPreferredSize(new Dimension(360,210));
      add(pane);
      this.setViewportView(pane);
   }

// Get each of the fields
   public String getBadgeID() { return badgeid.getText(); }
   public _Badge_Holder getBadgeHolder() { return badgeholder; }
   public byte[] getID() {
      StringTokenizer st = new StringTokenizer(badgeid.getText());
      byte[] temp = new byte[st.countTokens()];
      for (int i=0; i<temp.length; i++){
	String s= st.nextToken();
	System.err.println("@"+s+"@");
         temp[i] = Byte.valueOf( s, 16).byteValue();
      }
      return temp;
   }

// Set itch of the fields
   public void setBadgeID(String value) { badgeid.setText(value); }
   public void setBadgeHolder(_Badge_Holder bholder) { badgeholder = bholder; }
   public void setID(byte[] abyte){
      String temp = new String("");
      for (int i=0; i<abyte.length; i++){
         temp = temp+Integer.toString(abyte[i], 16)+" ";
      }
      badgeid.setText(temp);
   }

// Clear all fields
   public void clear(){
      badgeid.setText("");
      badgeholder = null;
      holder.setText("< EMPTY >");
   }

// Chack if all filds are filled
   public boolean check(){
      if (badgeid.getText().compareTo("") == 0) return false;
//      if (badgeholder == null) return false;
      return true;
   }

// Just copy the content of source badge
   public void copy(ItemPanel source){
      badgeid.setText(((BadgePanel)source).getBadgeID());
      badgeholder = ((BadgePanel)source).getBadgeHolder();
   }
   
   public void setData(org.omg.CORBA.Object source){
      
      Badge badge = BadgeHelper.narrow(source);
      object = source;
      byte[] id;
      String temp = new String("");
      
      id = badge.id();
      setID(id);
      try {
         badgeholder = badge.holder();
         if (badgeholder == null) {
            holder.setEnabled(state);
         } else {
            holder.setEnabled(true);
         }
      } catch(Exception e) {
         badgeholder = null;
         holder.setEnabled(state);
      }
      holder.setText(RepGet.DescriptBadgeHolder(badgeholder));
      repaint();
   }
 
// Build pattern for find function

   public ABng_Core_System.BadgePackage.Pattern buildPattern(){
      return RepGet.BuildBadgePattern( "", getID());
   }  
/////////////////////////////////
/* Reaction for button clicked */
/////////////////////////////////

   protected final class BadgeClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == holder){
            if (type == 0){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               ViewDialog dlg = new ViewDialog(parent, RepName.holderRep, badgeholder);
               if (dlg.getAnswer()){
                  RepGet repository = new RepGet();
                  repository.init(RepName.badgeRep);
                  repository.update(object, getID(), dlg.getObject());
                  setData(object);
               }	
               dlg.dispose();
            } else if (type == 1){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               RepositoryReferenceDialog dlg = null;
               if (badgeholder == null)
                  dlg = new RepositoryReferenceDialog(parent, RepName.holderRep);
               else dlg =  new RepositoryReferenceDialog(parent, RepName.holderRep, badgeholder.item_id()); 
               if (dlg.getAnswer()){
                  badgeholder = _Badge_HolderHelper.narrow(dlg.getObject());
                  if (badgeholder == null) {
                     holder.setEnabled(false);
                  } else {
                     holder.setEnabled(true);
                  }
                  holder.setText(RepGet.DescriptBadgeHolder(badgeholder));
               }
               dlg.dispose();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2){
               System.out.println("Not suported");
            }
         }
      }
   }

}
