package ABngSystem;
 
import java.awt.*;
import java.awt.event.*;
import java.util.*;
 
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
 
/////////////////////////////////////////
/* This class shows a window when user wants to
   update the selected item. It's just item form
   and Accept and Cancel button */
/////////////////////////////////////////
 
class FindDialog extends JDialog{
 
   JButton accept;
   JButton cancel;
   JDialog wnd;
   boolean answer;
   public ItemPanel localitem;
   String repname;
 
   public FindDialog(Window parent, String repname){
      super((JFrame)parent, repname+" - Fill Pattern", true);
      setFont(new Font("Dialog", Font.PLAIN, 14));
      setSize(383,382);
      setResizable(false);
      addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent e) {setVisible(false); }
        });
 
      JPanel pane = new JPanel();
      pane.setLayout(null);
      wnd = this;
      answer = false;
      this.repname = repname;
 
      if (repname.equals(RepName.userRep))
         localitem = new UserPanel(true, 2, parent);
      else if (repname.equals(RepName.sensorRep))
         localitem = new SensorPanel(true, 2, parent);
      else if (repname.equals(RepName.badgeRep))
         localitem = new BadgePanel(true, 2, parent);
      else if (repname.equals(RepName.holderRep))
         localitem = new HolderPanel(true, 2, parent);
      else if (repname.equals(RepName.locationTypeRep))
         localitem = new LocationTypePanel(false, 2, parent);
      else if (repname.equals(RepName.locationDescRep))
         localitem = new LocationDescPanel(false, 2, parent);
      else if (repname.equals(RepName.abngldRep))
         localitem = new AbngldPanel(false, 2, parent);
      else if (repname.equals(RepName.viewRep))
         localitem = new ViewPanel(false, 2, parent);
      localitem.setLocation(5,5);
      pane.add(localitem);
 
      ButtonClicked bc = new ButtonClicked();
      accept = new JButton("Accept");
      accept.setSize(125,25);
      accept.setLocation(45,325);
      accept.addActionListener(bc);
      accept.setToolTipText("Accept pattern");
      pane.add(accept);
      cancel = new JButton("Cancel");
      cancel.setSize(125,25);
      cancel.setLocation(205,325);
      cancel.addActionListener(bc);
      cancel.setToolTipText("Discard pattern");
      pane.add(cancel);
 
      setContentPane(pane);
      setVisible(true);
   }
 
   public boolean getAnswer(){ return answer; }
   public ItemPanel getPanel() { return localitem; }
 
 
///////////////////////////////////////////
/* What to do when the user click button */
///////////////////////////////////////////
 
   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == accept){
            if (repname.equals(RepName.badgeRep)){
               try {
                  ((BadgePanel) localitem).getID();
                  answer = true;
                  wnd.setVisible(false);
               } catch (NumberFormatException ex) {
                  JOptionPane.showMessageDialog(wnd, "Please enter a valid number as badge ID", "Can't add item", JOptionPane.ERROR_MESSAGE);
               }
            } else {
               answer = true;
               wnd.setVisible(false);
            }
         }
         else if (((JButton) e.getSource()) == cancel){
            answer = false;
            wnd.setVisible(false);
         }
      }
   }
}
 
