package ABngSystem;
 
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;
 
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
 
import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;
 
//////////////////////////////////////////////////
/* This class represents a graphic "part" of itch location description 
   It just shows badge's fields to user.
   Few methods to manage this fields */
///////////////////////////////////////
 
class LocationDescPanel extends ItemPanel{
 
   boolean state;
   int type;
   int index;
   Window parent;
   org.omg.CORBA.Object object;
 
   JTextField name;
   JList proplist;
   JButton add;
   JButton remove;
   JButton propbutton;
   String[] propnames;
   Domain_Repository.Property[] properties;
   Domain_Repository.Property_Pattern[] proppattern;

   public LocationDescPanel(boolean state, int type, Window parent){
 
      JPanel pane = new JPanel();
      pane.setLayout(null);
      this.state = state;
      this.type = type;
      this.parent = parent;
      object = null;
      index = -1;
 
      propnames = new String[0];
      properties = new Domain_Repository.Property[0];
 
      JLabel label;
      label = new JLabel("Location_Description name:");
      label.setSize(330,15);
      label.setLocation(10,10);
      pane.add(label);
      name = new JTextField();
      name.setSize(315,20);
      name.setLocation(25,30);
      name.setEnabled(state);
      pane.add(name);
 
      label = new JLabel("Properties list:");
      label.setSize(330,15);
      label.setLocation(10,60);
      pane.add(label);
      proplist = new JList(propnames);
      proplist.setLocation(0,0);
      proplist.addListSelectionListener(new ItemChanged());
      proplist.addMouseListener(new ItemClicked());
      JScrollPane scrollpane = new JScrollPane(proplist);
      scrollpane.setSize(315,150);
      scrollpane.setLocation(25,80);
      pane.add(scrollpane);

      LocationDescClicked ldc = new LocationDescClicked();
      propbutton = new JButton("Display selected property");
      propbutton.setSize(315,20);
      propbutton.setLocation(25,240);
      propbutton.setEnabled(false);
      propbutton.addActionListener(ldc);
      pane.add(propbutton);
 
      add = new JButton("Add property");
      add.setSize(150, 20);
      add.setLocation(25, 270);
      add.setEnabled(state);
      add.addActionListener(ldc);
      pane.add(add);
      remove = new JButton("Remove property");
      remove.setSize(150, 20);
      remove.setLocation(190, 270);
      remove.setEnabled(false);
      remove.addActionListener(ldc);
      pane.add(remove);
 
      if (type == 2){
         add.setText("Add Property Pattern");
         remove.setText("Remove Property Pattern");
      }
 
      proppattern = new Domain_Repository.Property_Pattern[0];
      pane.setPreferredSize(new Dimension(360,270));
      add(pane);
      this.setViewportView(pane);
   }
 
// Get itch of the fields
   public String getName() { return name.getText(); }
   public Domain_Repository.Property[] getProperties() { return properties; }
 
// Set itch of the fields
   public void setName(String value) { name.setText(value); }
   public void setProperties(Domain_Repository.Property[] value) { properties = value; }
 
// Clear all fields
   public void clear(){
      name.setText("");
      properties = new Domain_Repository.Property[0];
      proppattern = new Domain_Repository.Property_Pattern[0];
      propnames = new String[0];
      proplist.setListData(propnames);
      proplist.repaint();
      proplist.revalidate();
      propbutton.setEnabled(false);
      remove.setEnabled(false);
   }
 
// Chack if all filds are filled
   public boolean check(){
      if (name.getText().compareTo("") == 0) return false;
      return true;
   }
 
// Just copy the content of source badge
   public void copy(ItemPanel source){
   }
 
   public void setData(org.omg.CORBA.Object source){
 
      Domain_Repository.Location_Description ld = Domain_Repository.Location_DescriptionHelper.narrow(source);
      object = source;

      name.setText(ld.type_name()); 
      propnames = new String[0];
      proplist.setListData(propnames);
      proplist.repaint();
      proplist.revalidate();
      propbutton.setEnabled(false);
      remove.setEnabled(false);
      properties = ld.property_list();
      if (properties == null) {
         properties =  new Domain_Repository.Property[0];
      }
      propnames = new String[properties.length];
      for (int i=0; i<properties.length; i++){
         propnames[i] = new String(properties[i].name);
      }
      proplist.setListData(propnames);
      proplist.repaint();
      proplist.revalidate();
      propbutton.setEnabled(false);
      remove.setEnabled(false);
      repaint();
   }
 
// Build pattern for find function
 
   public Domain_Repository.Location_DescriptionPackage.Pattern buildPattern(){
      return null;
   }
 
/////////////////////////////////
/* Reaction for button clicked */
/////////////////////////////////
 
   protected final class LocationDescClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == propbutton){
            System.out.println("Selected index: "+index);
            System.out.println(properties[index].value);
/////////////////////////////////////////////////////////////////
/* Here you have to put some code to display (and/or edit) Property (Any Type).
   Sorry, but that was impossible for us*/
//////////////////////////////////////////////////////////////// 
         }
         else if (((JButton) e.getSource()) == add){
            if (type == 1){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
////////////////////////////////////////////////////////////////
/* Here you have to create new Property (Type any). When you do this
   just put property into pd object */
//////////////////////////////////////////////////////////////
               PWindow dlg = new PWindow(parent);
               dlg.setVisible(true);
               if (dlg.getAnswer()){
                  Domain_Repository.Property pd = dlg.getProperty();
                     parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                     int count = properties.length;
                     Domain_Repository.Property[] old = properties;
                     String[] oldnames = propnames;
                     properties = new Domain_Repository.Property[count+1];
                     propnames = new String[count+1];
                     for (int i=0; i<count; i++){
                        properties[i] = old[i];
                        propnames[i] = oldnames[i];
                     }
                     properties[count] = pd;
                     propnames[count] = pd.name;
                     proplist.setListData(propnames);
                     proplist.repaint();
                     proplist.revalidate();
               }
               dlg.dispose();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
/////////////////////////////////////////////////////////////////////////
/* Here you have to build property pattern. You can do this by youself or
   put PROPERTY object into pd varible */
////////////////////////////////////////////////////////////////////
               PWindow dlg = new PWindow(parent);
               dlg.setVisible(true);
               if (dlg.getAnswer()){
                  int count = proppattern.length;
                  Domain_Repository.Property_Pattern[] old = proppattern;
                  String[] oldnames = propnames;
                  proppattern = new Domain_Repository.Property_Pattern[count+1];
                  propnames = new String[count+1];
                  for (int i=0; i<count; i++){
                     proppattern[i] = old[i];
                     propnames[i] = oldnames[i];
                  }
                  Domain_Repository.Property pd = dlg.getProperty();
                  proppattern[count] = RepGet.BuildPropertyPattern(pd);
                  propnames[count] = "Property Description Pattern";
                  proplist.setListData(propnames);
                  proplist.repaint();
                  proplist.revalidate();
               }
               dlg.dispose();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
         }
         else if (((JButton) e.getSource()) == remove){
            if (type == 1) {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                  int count = properties.length;
                  for (int i=index; i<count-1; i++){
                     properties[i] = properties[i+1];
                     propnames[i] = propnames[i+1];
                  }
                  properties[count-1] = null;
                  propnames[count-1] = null;
                  Domain_Repository.Property[] old = properties;
                  String[] oldnames = propnames;
                  properties = new Domain_Repository.Property[count-1];
                  propnames = new String[count-1];
                  for (int i=0; i<count-1; i++){
                     properties[i] = old[i];
                     propnames[i] = oldnames[i];
                  }
                  proplist.setListData(propnames);
                  proplist.repaint();
                  proplist.revalidate();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2) {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               int count = proppattern.length;
               for (int i=index; i<count-1; i++){
                  proppattern[i] = proppattern[i+1];
                  propnames[i] = propnames[i+1];
               }
               proppattern[count-1] = null;
               propnames[count-1] = null;
               Domain_Repository.Property_Pattern[] old = proppattern;
               String[] oldnames = propnames;
               proppattern = new Domain_Repository.Property_Pattern[count-1];
               propnames = new String[count-1];
               for (int i=0; i<count-1; i++){
                  proppattern[i] = old[i];
                  propnames[i] = oldnames[i];
               }
               proplist.setListData(propnames);
               proplist.repaint();
               proplist.revalidate();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
            remove.setEnabled(false);
            propbutton.setEnabled(false);
         }
      }
   }

//////////////////////////////////////
/* This class response when the user
   click on an item */
//////////////////////////////////////
 
   protected final class ItemChanged implements ListSelectionListener{
      public void valueChanged(ListSelectionEvent e){
         index = proplist.getSelectedIndex();
         if (index!=-1){
            if (type != 2) propbutton.setEnabled(true);
            if (state) remove.setEnabled(true);
         }
      }
   }

   protected final class ItemClicked extends MouseAdapter{
      public void mouseClicked(MouseEvent e){
         if (e.getClickCount() == 2){
            if (e.getSource() == proplist){
               propbutton.doClick();
            }
         }
         super.mouseClicked(e);
      }
   }
 
}
 

