package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;
 
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
 
import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;
import Domain_Repository.*;
import org.omg.CORBA.*;

////////////////////////////////////////
/* This class supported Property Desription objects
   and Type Code*/
//////////////////////////////////////

class PDWindow extends JDialog{

   JComboBox type;
   JTextField name;
   JButton cancel;
   JButton accept;
   boolean answer;
   JDialog wnd;

   public PDWindow(Window parent){
      super((JFrame)parent, "Property description", true);
      setFont(new Font("Dialog", Font.PLAIN, 14));
      setSize(230,180);
      setResizable(false);
      addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent e) {setVisible(false); }
        });
 
      JPanel pane = new JPanel();
      pane.setLayout(null);
      wnd = this;
      answer = false;

      JLabel label = new JLabel("Type:");
      label.setSize(200,15);
      label.setLocation(10,10);
      pane.add(label);
      type = new JComboBox();
      type.setSize(200,20);
      type.setLocation(10,30);
      type.addItem("long");
      type.addItem("boolean");
      type.addItem("obj_ref");
      type.addItem("string");
      type.addItem("char");
      type.addItem("sequence");
      type.addItem("void");
      type.addItem("octet");
      type.addItem("null");
      type.addItem("any");
      type.addItem("short");
      type.addItem("type code");
      pane.add(type);

      label = new JLabel("Name:");
      label.setSize(200,15);
      label.setLocation(10, 60);
      pane.add(label);
      name = new JTextField();
      name.setSize(200,20);
      name.setLocation(10,80);
      pane.add(name);

      ButtonClicked bc = new ButtonClicked();
      cancel = new JButton("Cancel");
      cancel.setSize(80,30);
      cancel.setLocation(110, 110);
      cancel.addActionListener(bc);
      pane.add(cancel);

      accept = new JButton("Accept");
      accept.setSize(80,30);
      accept.setLocation(20,110);
      accept.addActionListener(bc);
      pane.add(accept);
      setContentPane(pane);
   }

   public boolean getAnswer() { return answer; }

   public void setData(Property_Description pd){
      if (pd.type.kind() == TCKind.tk_long) type.setSelectedItem("long");
      else if (pd.type.kind() == TCKind.tk_boolean) type.setSelectedItem("boolean");
      else if (pd.type.kind() == TCKind.tk_objref) type.setSelectedItem("obj_ref");
      else if (pd.type.kind() == TCKind.tk_string) type.setSelectedItem("string");
      else if (pd.type.kind() == TCKind.tk_char) type.setSelectedItem("char");
      else if (pd.type.kind() == TCKind.tk_sequence) type.setSelectedItem("sequence");
      else if (pd.type.kind() == TCKind.tk_void) type.setSelectedItem("void");
      else if (pd.type.kind() == TCKind.tk_octet) type.setSelectedItem("octet");
      else if (pd.type.kind() == TCKind.tk_null) type.setSelectedItem("null");
      else if (pd.type.kind() == TCKind.tk_any) type.setSelectedItem("any");
      else if (pd.type.kind() == TCKind.tk_short) type.setSelectedItem("short");

      name.setText(pd.name);
   }
   
   public Property_Description getPD() {
      int index = type.getSelectedIndex();
      /* OrbixWeb-specific

      if (index == 0) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_long));
      if (index == 1) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_boolean));
      if (index == 2) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_objref));
      if (index == 3) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_string));
      if (index == 4) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_char));
      if (index == 5) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_sequence));
      if (index == 6) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_void));
      if (index == 7) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_octet));
      if (index == 8) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_null));  
      if (index == 9) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_any));  
      if (index == 10) return new Property_Description(name.getText(), new IE.Iona.OrbixWeb.CORBA.TypeCode(TCKind.tk_short));  
      */
      return null;
   }
   
   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == accept){
            answer = true;
            setVisible(false);
         }
         else if (((JButton) e.getSource()) == cancel){
            setVisible(false);
         }
      }
   }
}
