package ABngSystem;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;

/////////////////////////////////////////////////////
/* Main repository window. When user clicked on
   a repository name in the application window
   he(she) see this one. It contains four panels:
   BrowsePanel, AddPanel, UpdatePanel and FindPanel.*/
//////////////////////////////////////////////////////

class RepositoryDialog extends JFrame {

   JTabbedPane tabbedpane;
   BrowsePanel bpanel; 
   AddPanel apanel;
   UpdatePanel upanel;
   FindPanel fpanel;
   RepGet repository;
   JButton close;
   JFrame wnd;

   public RepositoryDialog(String repname){
      super(repname+" - Main Repository Window");
      setBackground(Color.lightGray);
      setFont(new Font("Dialog", Font.PLAIN, 14));
      setSize(610,472);
      setResizable(false);
      addWindowListener(new WindowAdapter() {
              public void windowClosing(WindowEvent e) {
                 dispose(); 
                 super.windowClosing(e);
              }
        });
      JPanel pane = new JPanel();
      pane.setLayout(null);
      repository = new RepGet();
      repository.init(repname);
      this.wnd = this;

      tabbedpane = new JTabbedPane();
      tabbedpane.setSize(600, 400);
      tabbedpane.setLocation(0,0);
      bpanel = new BrowsePanel(this, repname, repository);
      bpanel.setLocation(0,0);
      if (repname.equals(RepName.viewRep)){
         bpanel.remove(bpanel.remove);
         bpanel.remove(bpanel.update);
      }
      tabbedpane.addTab("Browse", bpanel);
      tabbedpane.setSelectedIndex(0);
      if (!(repname.equals(RepName.viewRep))){
         apanel = new AddPanel(this, repname, repository);
         tabbedpane.addTab("Add", apanel);
      }
      upanel = new UpdatePanel(this, repname, repository);
      if (repname.equals(RepName.viewRep)) upanel.remove(upanel.accept);
      tabbedpane.addTab("Update", upanel);
      if (!(repname.equals(RepName.viewRep))){
         fpanel = new FindPanel(this, repname, repository);
         tabbedpane.addTab("Find", fpanel);
      }
      pane.add(tabbedpane);

      close = new JButton("Close");
      close.setSize(125,25);
      close.setLocation(425,410);
      close.addActionListener(new ButtonClicked());
      close.setToolTipText("Close this window");
      pane.add(close);

      setContentPane(pane);
      setVisible(true);
   }
   
   public void updateList(){
      bpanel.updateList();
      upanel.updateList();
//      fpanel.updateList();
   }
   
   public void selectItem(int itemid){
      bpanel.selectItem(itemid);   
      upanel.selectItem(itemid);
   }

   protected final class ButtonClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         wnd.dispose();
      }
   }   
}


