package ABngSystem;
 
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.lang.*;
 
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;
 
import ABng_Core.*;
import ABng_Core_System.*;
import ABng_Core_Management.*;
 
//////////////////////////////////////////////////
/* This class represents a graphic "part" of itch view manager
   It just shows view's fields to user.
   Few methods to manage this fields */
///////////////////////////////////////
 
class ViewPanel extends ItemPanel{
 
   boolean state;
   int type;
   int locationsindex;
   int locatablesindex;
   Window parent;
   org.omg.CORBA.Object object;
   RepGet repository;
 
   JTextField viewname;
   JTextField viewtype;
   JCheckBox duplicate;

   JList locationslist;
   JButton locationbutton;
   JButton addlocation;
   JButton removelocation;
   String[] locationsnames;
   ABng_Core.Location[] locations;
 
   JList locatableslist;
   JButton locatablebutton;
   JButton addlocatable;
   JButton removelocatable;
   String[] locatablesnames;
   ABng_Core.Locatable[] locatables;
 
   public ViewPanel(boolean state, int type, Window parent){
 
      JPanel pane = new JPanel();
      pane.setLayout(null);
      this.state = state;
      this.type = type;
      this.parent = parent;
      object = null;
      locationsindex = -1;
      locatablesindex = -1;
      repository = new RepGet();
      repository.init(RepName.viewRep);
 
// GLOBAL
      JLabel label;
      label = new JLabel("View name:");
      label.setSize(330,15);
      label.setLocation(10,10);
      pane.add(label);
      viewname = new JTextField();
      viewname.setSize(315,20);
      viewname.setLocation(25,30);
      viewname.setEnabled(state);
      pane.add(viewname);

      label = new JLabel("View type");
      label.setSize(330,15);
      label.setLocation(10,60);
      pane.add(label);
      viewtype = new JTextField();
      viewtype.setSize(315,20);
      viewtype.setLocation(25,80);
      viewtype.setEnabled(state);
      pane.add(viewtype);

      duplicate = new JCheckBox(" wants duplicates ?");
      duplicate.setSize(315,15);
      duplicate.setLocation(10,110);
      duplicate.setEnabled(state);
      pane.add(duplicate);

      ItemClicked ic = new ItemClicked();
// LOCATIONS
      locationsnames = new String[0];
      locations = new ABng_Core.Location[0];
      LocationClicked lc = new LocationClicked();
      label = new JLabel("Locations list:");
      label.setSize(330,15);
      label.setLocation(10,130);
      pane.add(label);
      locationslist = new JList(locationsnames);
      locationslist.setLocation(0,0);
      locationslist.addListSelectionListener(new LocationChanged());
      locationslist.addMouseListener(ic);
      JScrollPane scrollpane = new JScrollPane(locationslist);
      scrollpane.setSize(315,150);
      scrollpane.setLocation(25,150);
      pane.add(scrollpane);
 
      locationbutton = new JButton("Display selected location");
      locationbutton.setSize(315,20);
      locationbutton.setLocation(25,310);
      locationbutton.setEnabled(false);
      locationbutton.addActionListener(lc);
      pane.add(locationbutton);
 
      addlocation = new JButton("Add location");
      addlocation.setSize(150, 20);
      addlocation.setLocation(25, 340);
      addlocation.setEnabled(state);
      addlocation.addActionListener(lc);
      pane.add(addlocation);
      removelocation = new JButton("Remove location");
      removelocation.setSize(150, 20);
      removelocation.setLocation(190, 340);
      removelocation.setEnabled(false);
      removelocation.addActionListener(lc);
      pane.add(removelocation);
 
// LOCATABLES
      locatablesnames = new String[0];
      locatables = new ABng_Core.Locatable[0];
      LocatableClicked lac = new LocatableClicked();
      label = new JLabel("Locatables list:");
      label.setSize(330,15);
      label.setLocation(10,370);
      pane.add(label);
      locatableslist = new JList(locatablesnames);
      locatableslist.setLocation(0,0);
      locatableslist.addListSelectionListener(new LocatableChanged());
      locatableslist.addMouseListener(ic);
      scrollpane = new JScrollPane(locatableslist);
      scrollpane.setSize(315,150);
      scrollpane.setLocation(25,390);
      pane.add(scrollpane);
 
      locatablebutton = new JButton("Display selected locatable");
      locatablebutton.setSize(315,20);
      locatablebutton.setLocation(25,550);
      locatablebutton.setEnabled(false);
      locatablebutton.addActionListener(lac);
      pane.add(locatablebutton);
 
      addlocatable = new JButton("Add locatable");
      addlocatable.setSize(150, 20);
      addlocatable.setLocation(25, 580);
      addlocatable.setEnabled(state);
      addlocatable.addActionListener(lac);
      pane.add(addlocatable);
      removelocatable = new JButton("Remove locatable");
      removelocatable.setSize(150, 20);
      removelocatable.setLocation(190, 580);
      removelocatable.setEnabled(false);
      removelocatable.addActionListener(lac);
      pane.add(removelocatable);
 
      if (type == 2){
         addlocation.setText("Add Location Pattern");
         removelocation.setText("Remove Location Pattern");
         addlocatable.setText("Add Locatable Pattern");
         removelocatable.setText("Remove Locatable Pattern");
      }
 
      pane.setPreferredSize(new Dimension(360,610));
      add(pane);
      this.setViewportView(pane);
   }
 
// Get itch of the fields
   public String getName() { return viewname.getText(); }
   public String getType() { return viewtype.getText(); }
   public boolean getDuplicates() { return duplicate.isSelected(); }
   public ABng_Core.Location[] getLocations() { return locations; }
   public ABng_Core.Locatable[] getLocatables() { return locatables; }
 
// Set itch of the fields
   public void setName(String value) { viewname.setText(value); }
   public void setType(String value) { viewtype.setText(value); }
   public void setDuplicates(boolean value) { duplicate.setSelected(value); }
   public void setLocations(ABng_Core.Location[] value) { locations = value; }
   public void setLocatables(ABng_Core.Locatable[] value) { locatables = value; }
 
// Clear all fields
   public void clear(){
      viewname.setText("");
      viewtype.setText("");
      duplicate.setSelected(false);
      locations = new ABng_Core.Location[0];
      locationsnames = new String[0];
      locationslist.setListData(locationsnames);
      locationslist.repaint();
      locationslist.revalidate();
      locatables = new ABng_Core.Locatable[0];
      locatablesnames = new String[0];
      locatableslist.setListData(locatablesnames);
      locatableslist.repaint();
      locatableslist.revalidate();
   }
 
// Chack if all filds are filled
   public boolean check(){
      return true;
   }
 
// Just copy the content of source badge
   public void copy(ItemPanel source){
   }
 
   public void setData(org.omg.CORBA.Object source){
 
      ABng_Core_Management.View_Manager vm = ABng_Core_Management.View_ManagerHelper.narrow(source);
      object = source;
 
      viewname.setText(vm.my_view().view_name());
      viewtype.setText(vm.my_view().type());
      duplicate.setSelected(vm.my_view().wants_duplicates());
 
      RGContainer rg = repository.listLocations(vm);
      if (rg.IsError())
         JOptionPane.showMessageDialog(parent, rg.GetErrorText(), "Locations List Error", JOptionPane.ERROR_MESSAGE);
      int count = rg.GetObjects().length;
      locations = new ABng_Core.Location[count];
      if (count > 0){
         for (int i=0; i<count; i++){
            locations[i] = ((ABng_Core.Location) rg.GetObjects()[i]);
         }
      }
      locationsnames = rg.GetStrings();
      locationslist.setListData(locationsnames);
      locationslist.repaint();
      locationslist.revalidate();
      locationbutton.setEnabled(false);
      removelocation.setEnabled(false);

      rg = repository.listLocatables(vm);
      if (rg.IsError())
         JOptionPane.showMessageDialog(parent, rg.GetErrorText(), "Locatables List Error", JOptionPane.ERROR_MESSAGE);
      count = rg.GetObjects().length;
      locatables = new ABng_Core.Locatable[count];
      if (count > 0){
         for (int i=0; i<count; i++){
            locatables[i] = ((ABng_Core.Locatable) rg.GetObjects()[i]);
         }
      }
      locatablesnames = rg.GetStrings();
      locatableslist.setListData(locatablesnames);
      locatableslist.repaint();
      locatableslist.revalidate();
      locatablebutton.setEnabled(false);
      removelocatable.setEnabled(false);
      repaint();
   }
// Build pattern for find function
 
 
/////////////////////////////////
/* Reaction for button clicked */
/////////////////////////////////
 
   protected final class LocationClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == locationbutton){
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            ABng_Core_System.ABng_Location_Description ld = (ABng_Core_Management.View_ManagerHelper.narrow(object).deref_location(locations[locationsindex]));
            ViewDialog dlg = new ViewDialog(parent, RepName.abngldRep, ld);
            if (dlg.getAnswer()){
            }
            dlg.dispose();
         }
         else if (((JButton) e.getSource()) == addlocation){
            if (type == 1){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               RepositoryReferenceDialog dlg;
               dlg = new RepositoryReferenceDialog(parent, RepName.abngldRep);
               if (dlg.getAnswer()){
                     parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                     String mesg = repository.addLocation(object, dlg.getObject());
                     if (mesg.equals("OK"))
                        setData(object);
                     else
                        JOptionPane.showMessageDialog(parent, mesg, "Can't add location", JOptionPane.ERROR_MESSAGE);
               }
               dlg.dispose();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2){
            }
         }
         else if (((JButton) e.getSource()) == removelocation){
            if (type == 1) {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                  String mesg = repository.removeLocation(object, locations[locationsindex]);
                  if (mesg.equals("OK"))
                     setData(object);
                  else
                     JOptionPane.showMessageDialog(parent, mesg, "Can't remove location", JOptionPane.ERROR_MESSAGE);
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2) {
            }
            removelocation.setEnabled(false);
            locationbutton.setEnabled(false);
         }
      }
   }
 
//////////////////////////////////////
/* This class response when the user
   click on an item */
//////////////////////////////////////
 
   protected final class LocationChanged implements ListSelectionListener{
      public void valueChanged(ListSelectionEvent e){
         locationsindex = locationslist.getSelectedIndex();
         if (locationsindex!=-1){
            if (type != 2) locationbutton.setEnabled(true);
            if (state) removelocation.setEnabled(true);
         }
      }
   }
 
 
/////////////////////////////////
/* Reaction for button clicked */
/////////////////////////////////
 
   protected final class LocatableClicked implements ActionListener{
      public void actionPerformed(ActionEvent e){
         if (((JButton) e.getSource()) == locatablebutton){
            parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            _Badge_Holder bh = (ABng_Core_Management.View_ManagerHelper.narrow(object).deref_locatable(locatables[locatablesindex]));
            ViewDialog dlg = new ViewDialog(parent, RepName.holderRep, bh);
            if (dlg.getAnswer()){
            }
            dlg.dispose();
         }
         else if (((JButton) e.getSource()) == addlocatable){
            if (type == 1){
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
               RepositoryReferenceDialog dlg;
               dlg = new RepositoryReferenceDialog(parent, RepName.holderRep);
               if (dlg.getAnswer()){
                     parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                     String mesg = repository.addLocatable(object, dlg.getObject());
                     if (mesg.equals("OK"))
                        setData(object);
                     else
                        JOptionPane.showMessageDialog(parent, mesg, "Can't add locatable", JOptionPane.ERROR_MESSAGE);
               }
               dlg.dispose();
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2){
            }
         }
         else if (((JButton) e.getSource()) == removelocatable){
            if (type == 1) {
               parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
                  String mesg = repository.removeLocatable(object, locatables[locatablesindex]);
                  if (mesg.equals("OK"))
                     setData(object);
                  else
                     JOptionPane.showMessageDialog(parent, mesg, "Can't remove locatable", JOptionPane.ERROR_MESSAGE);
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else if (type == 2) {
            }
            removelocatable.setEnabled(false);
            locatablebutton.setEnabled(false);
         }
      }
   }
 
//////////////////////////////////////
/* This class response when the user
   click on an item */
//////////////////////////////////////
 
   protected final class LocatableChanged implements ListSelectionListener{
      public void valueChanged(ListSelectionEvent e){
         locatablesindex = locatableslist.getSelectedIndex();
         if (locatablesindex!=-1){
            if (type != 2) locatablebutton.setEnabled(true);
            if (state) removelocatable.setEnabled(true);
         }
      }
   }
 
///////////////////////////////////////////////
/* Class for mouse DoubleClick on lists */
/////////////////////////////////////////

   protected final class ItemClicked extends MouseAdapter{
      public void mouseClicked(MouseEvent e){
         if (e.getClickCount() == 2){
            if (e.getSource() == locationslist){
               locationbutton.doClick();
            } else if (e.getSource() == locatableslist){
               locatablebutton.doClick();
            }
         }
         super.mouseClicked(e);
      }
   }
}
