/* abng_tools.h
 * Tools for comunicate with Active Badge system
 * (c) 1998 Dariusz Zbik <zbik@ernie.icslab.agh.edu.pl>
 */

#ifndef _ABNG_TOOLS_H
#define _ABNG_TOOLS_H

#include "finger.h"

/* 'constructor' for abng_tools
 * You have to call this routine once at program start.
 * This routine make importat for abng system activites 
 * (connect to server)
 * function return 0 or error number
 * see also abng_destructor
 *
 * mapfile - this is name of file which map local loginname to abng uids
 *           this file is not necesary if abng uid (string) is equal to
 *           local loginname.  
 */
int abng_constructor(int argc, char *argv[], const char *mapfile);

void abng_destructor(void);


/* Function looking for user and fill PERSON structre.
 */
void abng_fill_it(PERSON *pn, const char *abng_uid);


/* Function print message associated with person
 */
void abng_show_message(PERSON *pn, const char *header);


#endif /* _ABNG_TOOLS_H */


