/*
 * X_screen_lock.cc
 * (c) 1998 Dariusz bik <zbik@dwd.interkom.pl>
 */

#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>

#include "X_screen_lock.hh"

X_screen_lock::X_screen_lock(const char *lock_command)
{
  int argc;
  char *pomptr;
  child = 0;
  args = NULL;
  if (lock_command == NULL)
    lock_command = DEFAULT_LOCK_COMMEND;

  pomptr = argbuff = new char[strlen(lock_command)+1];
  strcpy(pomptr, lock_command);
  argc=1;
  while ( (pomptr=strchr(pomptr, ' ')) )
  {
    pomptr++;
    argc++;
  }
  args = new char*[argc+1];

  args[argc=0] = pomptr = argbuff;
  while ( (pomptr=strchr(pomptr, ' ')) )
  {
    *pomptr=0;
    pomptr++;
    args[++argc]=pomptr;
  }
  args[++argc]=NULL;

  signal(SIGCHLD, SIG_IGN); // nie lubi zombie 
}

X_screen_lock::~X_screen_lock()
{
  unlock();
  if (argbuff)
    delete argbuff;
  if (args)
    delete[] args;
}

void X_screen_lock::unlock(void)
{
  if (child && !kill(child, 0))
  {
    if ( kill(child, SIGTERM) )
    //if ( kill(child, SIGKILL) )
      child = 0;
    else
    {
      sleep(1);
      if ( kill(child, SIGTERM) )
	child = 0;
    }
  }
  else
    child = 0; // nie ma ju dziecka
}

void X_screen_lock::lock(void)
{
  if (child)
    unlock();

  if ( !(child=vfork()) )
  {
    execvp(args[0], args+1);
    _exit(0); // nie udalo sie uruchomic procesu
  }

  if (child<0)
    child = 0; // by bd ale przy killu nie chc ubi wszystkich procesw.
}


/*END*/
