// A Device icon for ABng

package jabba;

import java.awt.*;
import java.awt.Image;
import java.util.Date;
import com.sun.java.swing.*;

public class Device extends JLabel {

//	public final static int MAXDEVCOUNT=30; 
//	private boolean rotated=false;

	String pc = "images/pc.gif";
	String workstation = "images/workstation.gif";
	String other = "images/other.gif";

	String 	name;
	String 	type;
	int 	width=35;
	int 	height=35;
	int 	xPos=0, yPos=0;
	double 	zoomFac=1;
	Image 	icon;
	Color 	color;
	int mask;

	public Device(String name, String type) {
	this.name = name;
	this.type = type;
	int typeOf;
	mask=0;

	Toolkit toolkit = Toolkit.getDefaultToolkit();

	if (type.equals( "PC")) typeOf = 0;
	else if (type.equals( "unix_workstation") ||
		type.equals( "unix_server" )) typeOf = 1;
	else typeOf = 2;

	// <SZ>
	switch (typeOf) {
		case 0 : 
		    // icon = toolkit.getImage(pc); 
		    icon = ResourceManager.loadIconFromResources(pc).getImage();
		    break; 
		case 1 : 
		    // icon = toolkit.getImage(workstation); 
		    icon = ResourceManager.loadIconFromResources(workstation).getImage();
		    break;
		default: 
		    // icon = toolkit.getImage(other); 
		    icon = ResourceManager.loadIconFromResources(other).getImage();
		    break;
	}
	// </SZ>

	setBounds(xPos, yPos, width, height);
	setPreferredSize(new Dimension(width, height));	
	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		g.drawImage(icon,0,0,(int) (width*zoomFac),
			(int)(height*zoomFac), color, this);
	}

	public String getInfo() {
		return (String)(name + " -  " + type);
	} 
	
/*	public boolean getRotated() {
		return rotated;
	}
*/
	public int getXPos(boolean rotated) {
		if (!rotated)
			return xPos;
		else
			return yPos;
	}

	public int getYPos(boolean rotated) {
		if (!rotated)
			return yPos;
		else 
			return xPos;
	}

	public int getDWidth() {
		return width;
	}

	public int getDHeight() {
		return height;
	}

	public void setZoom(double i) {
		zoomFac = i;
	}

	public void setXPos(int x) {
		xPos = x;
	}

	public void setYPos(int y) {	
		yPos = y;
	}
/*
	public void setRotated(boolean i) {
		rotated=i;
	}
*/
        public void setMask(int i) {
                mask = i;
        }
}
