// Door class for ABng system

package jabba;

import java.awt.*;
import java.lang.Math.*;
import com.sun.java.swing.*;

public class Door extends JPanel {

	private Color color = new Color(120,120,120);
	private int orig_x, orig_y;
	private int size_x, size_y;
	private double 	zoomFac=1;
//	private boolean rotated=false;

	public Door(int x, int y, int sx, int sy) {
	orig_x = x;
	orig_y = y;
	size_x = sx;
	size_y = sy;
	setLayout(null);
	setBackground(color);
	setBounds(orig_x, orig_y, size_x, size_y);
	setPreferredSize(new Dimension(size_x, size_y));
	setBorder(BorderFactory.createEtchedBorder());

	}
/*
	public void setRotated(boolean b) {
		rotated = b;
	}

	public boolean getRotated() {
		return rotated;
	}
*/
	public Color getColor() {
		return color;
	}

	public int getOrig_x(int room_sx, boolean rotated) {
		if (!rotated) 
			return orig_x;
		if ((orig_x==0) || (orig_x==room_sx)) 
			return (room_sx-orig_y-size_y);
		if (orig_y==0) return room_sx;
		return 0;
	}
	
	public int getOrig_y(boolean rotated) {
		if (!rotated)
			return orig_y;
		else return orig_x;
	}

	public int getSize_x(boolean rotated) {
		if (!rotated)
			return size_x;
		else return size_y;
	}

	public int getSize_y(boolean rotated) {
		if (!rotated)
			return size_y;
		else return size_x;
	}

	public void setZoom(double i) {
		zoomFac = i;
	}

	public void setColor(Color i) {
		color = i;
	}

	public void setSize_x(int x) {
		size_x = x;
	}
	
	public void setSize_y(int y) {
		size_y = y;
	}
	
	public void setOrig_x(int x) {
		orig_x = x;
	}

	public void setOrig_y(int y) {
		orig_y = y;
	}
}
