// Room class for ABng system

package jabba;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.sun.java.swing.*;
import com.sun.java.swing.text.*;
import com.sun.java.swing.border.Border;

public class Room extends JPanel {


	Runnable doTextPane = new Runnable() {
		public void run() {
			createTextPane(false);
		}
	};

	Rooms rooms;

	Border 	raisedB = BorderFactory.createRaisedBevelBorder();
	Border 	loweredB = BorderFactory.createLoweredBevelBorder();
	Border 	compound = BorderFactory.createCompoundBorder(raisedB,loweredB);
	private String newline = System.getProperty("line.separator"); 

	private boolean HumanVisible=true;
	private boolean DeviceVisible=true;
	private boolean rotated=false;

	private JTextPane textPane;

	private int currHX, currHY;
	private int currDX, currDY;
	private int dirHcount=0;
	private int dirDcount=0;

	private Vector insideHumans;
	private Vector insideDevices;
	private Vector doors;
	private Color color;
	private String number, description;
	private int orig_x, orig_y;
	private int size_x, size_y;
	private int item_id;
	private double zoomFac=1;
	private JLabel label;
	private Document doc;

	public Room(Color color2, String desc, String number2, int x,
					int y, int sx, int sy, int id) {
	color = color2;
	number = number2;
	description = desc;
	orig_x = x;
	orig_y = y;
	size_x = sx;
	size_y = sy;
	item_id = id;
	insideHumans = new Vector();
	insideDevices = new Vector();
	doors = new Vector();

	currDX = 10; currDY = 10;
	currHX = 50; currHY = 50;

	setLayout(null);
	setBounds(orig_x, orig_y, size_x, size_y);
	setPreferredSize(new Dimension(size_x, size_y));

	setBorder(BorderFactory.createCompoundBorder
		(compound,BorderFactory.createLineBorder(color,size_x)));

	label = new JLabel(number); 
	add(label);
	label.setBounds(5,180,35,20);
	label.setForeground(Color.black);

	addMouseListener(new MouseListener() {
			public void mousePressed(MouseEvent e) {}
                        public void mouseReleased(MouseEvent e) {}
                        public void mouseEntered(MouseEvent e) {}
                        public void mouseExited(MouseEvent e) {}
                        public void mouseClicked(MouseEvent e) {
				if (rooms.currentRoom == getRoom()) return;
				createTextPane(true);
				rooms.currentRoom=getRoom();
			}
	});
	}

	public Room getRoom() {
		return this;
	}

	public void createTextPane(boolean bstart) {

        int countString=0;

        String[] initString = new String[getHumSize()+getDevSize()+7];
        String[] initStyles = new String[getHumSize()+getDevSize()+7];

//        String[] initString = new String[Human.MAXHUMCOUNT+Device.MAXDEVCOUNT];
//        String[] initStyles = new String[Human.MAXHUMCOUNT+Device.MAXDEVCOUNT];
                initString[countString] = "ROOM: " + number + newline;
                initStyles[countString] = "large";
                countString++;

                initString[countString] = newline;
                initStyles[countString] = "regular";
                countString++;

                initString[countString] = "People: " + newline;
                initStyles[countString] = "bold";
                countString++;

                initString[countString] = newline;
                initStyles[countString] = "regular";
                countString++;
                        for (int i=0; i<getHumSize(); i++) {
				Human h = getHumanAt(i);
				if (h.mask == 3) continue;
                                initString[countString] = h.getInfo()+ newline;
                                initStyles[countString] = "italic";
                                countString++;
                        }

                initString[countString] = newline;
                initStyles[countString] = "regular";
                countString++;

                initString[countString] = "Equipment: " + newline;
                initStyles[countString] = "bold";
                countString++;

                initString[countString] = newline;
                initStyles[countString] = "regular";
		                countString++;

                        for (int i=0; i<getDevSize(); i++) {
				Device d = getDeviceAt(i);
				if (d.mask == 3) continue;
                                initString[countString] = d.getInfo()+newline;
                                initStyles[countString] = "italic";
                                countString++;
                        }
	if (bstart) initStylesForTextPane(textPane);
        doc = textPane.getDocument();

        try {
        doc.remove(0, doc.getLength());
        } catch(BadLocationException ble) {
                System.err.println("Couldnt remove room's info text.");
        }

       try {
            for (int i=0; i < countString; i++) {
                doc.insertString(doc.getLength(), initString[i],
                                 textPane.getStyle(initStyles[i]));
                textPane.setLogicalStyle(textPane.getStyle(initStyles[i]));
            }
        } catch (BadLocationException ble) {
            System.err.println("Couldn't insert initial text.");
        }
    }

    protected void initStylesForTextPane(JTextPane textPane) {

        //Initialize some styles
        Style def = StyleContext.getDefaultStyleContext().
                                        getStyle(StyleContext.DEFAULT_STYLE);

        Style regular = textPane.addStyle("regular", def);
        StyleConstants.setFontSize(def, 14);
        StyleConstants.setFontFamily(def, "SansSerif");

        Style s = textPane.addStyle("italic", regular);
        StyleConstants.setItalic(s, true);

        s = textPane.addStyle("bold", regular);
        StyleConstants.setBold(s, true);

        s = textPane.addStyle("small", regular);
        StyleConstants.setFontSize(s, 10);

        s = textPane.addStyle("large", regular);
        StyleConstants.setFontSize(s, 18);
    }

	public void setLabelBounds(int sx, int sy) {
		label.setBounds(5, sy-20, 35, 20);
	}

	public void people() {
		String s = "";
		Human h;
		for (int i=0; i<getHumSize(); i++) {
		h = getHumanAt(i);
		if (h.mask==3) continue;
		s += h.getFirstname().charAt(0);
		s += h.getLastname().charAt(0);
		s += ", ";
		}
		if (s.length() != 0) s = s.substring(0, s.length()-2);
		else s = null;	
		setToolTipText(s);
	}


	public void setTextPane(JTextPane jt) {
		textPane = jt;
	}

	public void setRooms(Rooms rs) {
		rooms = rs;
	}

	public Color getColor() {
		return color;
	}
		
	public String getNumber() {
		return number;
	}

	public String getDescription() {
		return description;
	}

	public int getOrig_x() {
		if (!rotated) 
			return orig_x;
		else 
			return rooms.getOrigmaxY() - orig_y - size_y; 
			
	}
	
	public int getOrig_y() {
		if (!rotated)
			return orig_y;
		else return orig_x;
	}

	public int getSize_x() {
		if (!rotated)
			return size_x;
		else return size_y;
	}

	public int getSize_y() {
		if (!rotated)
			return size_y;
		else return size_x;
	}

	public int getItem_id() {
		return item_id;
	}

	public void addH(Human h) {
		insideHumans.addElement(h);
		if (h.mask == 3) return;
		h.color = color;
		h.setXPos(currHX);
		h.setYPos(currHY);
		add(h);
		switch(dirHcount) {	
		    case 0: 
		        if (currHX + 25 <= getSize_x() - 80) {
			currHX += 25; break; }
		        else dirHcount++; 
		    case 1:
		        if (currHY + 30 <= getSize_y() - 80) { 
			currHY += 30; break; }
		        else dirHcount++; 
		    case 2:
		        if (currHX - 25 >= 40) {
			currHX -= 25; break; } 
		        else dirHcount++;
		    case 3:
		        if (currHY - 30 >= 40) {
			currHY -= 30; currHX += 30; break; }
		    else dirHcount=0;
		}
	}	

	public void delH(Human h) {
		insideHumans.removeElement(h);
		remove(h);
	}

	public void addD(Device d) {
		insideDevices.addElement(d);
		if (d.mask == 3) return;
		add(d);
		d.color=color;
		d.setXPos(currDX);
		d.setYPos(currDY);
		switch(dirDcount) {	
		case 0: 
		if (currDX + 50 <= getSize_x() - 40) { 
			currDX += 50; break; }
		else dirDcount++;
		case 1:
		if (currDY + 50 <= getSize_y() - 40) { 
			currDY += 50; break; }
		else dirDcount++; 
		case 2:
		if (currDX - 50 >= 0) { 
			currDX -= 50; break; }
		else dirDcount++;
		case 3:
		if (currDY- 50 >= 0)  {
			currDY -= 50; break; }
		else dirDcount=0;
		}
	}
	
	public int getHumSize() {
		return insideHumans.size();
	}

	public int getDevSize() {
		return insideDevices.size();
	}

	public int getSizeD() {
		return doors.size();
	}

	public Human getHumanAt(int i) {
		return (Human)insideHumans.elementAt(i);
	}

	public Device getDeviceAt(int i) {
		return (Device)insideDevices.elementAt(i);
	}

	public void addDoor(Door d) {
		doors.addElement(d);
		add(d);
	}

	public Door getDoorAt(int i) {
		return (Door)doors.elementAt(i);
	}

	public boolean getRotated() {
		return rotated;
	}

	public void setHumVis(boolean b) {
		HumanVisible=b;
		for(int i=0; i<getHumSize(); i++)
			getHumanAt(i).setVisible(HumanVisible);
	}

	public void setDevVis(boolean b) {
		DeviceVisible=b;
		for (int i=0; i<getDevSize(); i++)
			getDeviceAt(i).setVisible(DeviceVisible);
	}

	public void setZoom(double i) {
		zoomFac = i;
	}

	public void setRotated(boolean b) {
		rotated = b;
/*		for (int i=0; i<getHumSize(); i++)
			getHumanAt(i).setRotated(rotated);
		for (int i=0; i<getDevSize(); i++)
			getDeviceAt(i).setRotated(rotated);
		for (int i=0; i<getSizeD(); i++)
			getDoorAt(i).setRotated(rotated);
*/	}

	public void setColor(Color i) {
		color = i;
	}

	public void setNumber(String s) {
		number = s;
	}

	public void setDescription(String s) {
		description = s;
	}

	public void setSize_x(int x) {
		size_x = x;
	}
	
	public void setSize_y(int y) {
		size_y = y;
	}
	
	public void setOrig_x(int x) {
		orig_x = x;
	}

	public void setOrig_y(int y) {
		orig_y = y;
	}

	public void setItem_id(int i) {
		item_id = i;
	}

	public Vector allHumans() {
		return insideHumans;
	}

	public Vector allDevices() {
		return insideDevices;
	}

	public void setValue(){
	currDX = 10; currDY = 10;
	currHX = 50; currHY = 50;
	dirHcount=0;
	dirDcount=0;
	}
}
