package jabba;

// This class implements the table model for single user/location tabs

import com.sun.java.swing.table.AbstractTableModel;
import java.util.Vector;

class SimpleTableModel extends AbstractTableModel implements JabbaConstants {
  private class TableRow {
    String name;
    int id;
    TableRow( String n, int i ) {
      name = n;
      id = i;
    }
  }

//  TableRow[] rows;
  Vector rows;

  String columnName;
  Jabba jabba;

  SimpleTableModel( Jabba jabba,int[] userIds,String columnName ) {
    if( userIds!=null ) { 
//      rows = new TableRow[userIds.length];
      rows = new Vector();
      for( int i=0; i<userIds.length; i++ ) {
	rows.addElement(new TableRow( jabba.receiver.getUserFullName(userIds[i]),userIds[i] ));
      }
    }
    else 
      rows = null;

    this.columnName = columnName;
    this.jabba = jabba;
  }

  public int getRowCount() {
//    System.err.println( "getRowCount(): "+(((rows!=null)?rows.size():0)) );
    return (rows!=null)?rows.size():0;
  }

  public int getColumnCount() {
    return 1;
  }

  public String getColumnName( int col ) {
    return columnName;
  }

  public Object getValueAt( int row, int col ) {
    if( rows!=null ) return ((TableRow)(rows.elementAt(row))).name;
    else return null;
  }

  public void addRow( int id ) {
    if( rows==null ) rows=new Vector();
    rows.addElement(new TableRow(jabba.receiver.getUserFullName(id),id));
    int num=rows.size()-1;
    fireTableRowsInserted(num,num);
  }

  public void deleteRow( int id ) {
    if( rows==null ) return;
    int j=rows.size(),num=-1;
    for( int i=0; i<j; i++ ) {
      if( ((TableRow)(rows.elementAt(i))).id==id ) {
	num=i;
	break;
      }
    }
    if( num>=0 ) {
      System.err.println( "Removing row: "+num );
      rows.removeElementAt( num );
      fireTableRowsDeleted( num,num );
    }
    else System.err.println( "Row number less than zero!" );
  }

}




