package jabba;

import com.sun.java.swing.JTable;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JScrollPane;

import java.awt.Component;
import java.awt.BorderLayout;
import java.awt.Dimension;

import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;

import jabba.Human;

class ViewerMapTab extends JPanel implements ViewerTab {
  ViewerMapTableDataModel dataModel=null;
  String name;

  Jabba jabba;
  ScrollVR svr;

  ViewerMapTab( Jabba jabba, Viewer viewer ) {
    this( jabba,viewer,"Map" );
  }

  ViewerMapTab( Jabba jabba, Viewer viewer, String name ) {
    super( false );
    this.jabba = jabba;
    this.name = name;
    jabba.console.addWriter( this,"Viewer map tab" );
    setLayout( new BorderLayout() );
  }

  public void regenerate() {
    jabba.console.messageFrom( this, "regenerate() called." );
    // tworzymy model danych
    dataModel = new ViewerMapTableDataModel(jabba, this);


     jabba.receiver.registerDataModel( dataModel,
			Receiver.USER_MESSAGES | Receiver.EQUIPMENT_MESSAGES);

    Rooms rs = dataModel.makeRooms();
    rs = dataModel.insertPeople(rs);
    rs = dataModel.insertEquipment(rs);
    svr = new ScrollVR(rs);

     this.add(svr,BorderLayout.CENTER); 
  }    

  public void update() {
    jabba.console.messageFrom( this, "update() called." );
    if( dataModel==null ) regenerate();
    else jabba.receiver.updateDataModel( dataModel,
			Receiver.USER_MESSAGES | Receiver.EQUIPMENT_MESSAGES);
  }

  public JabbaDataModel getJabbaDataModel() {
    return dataModel;
  }

  public JPanel getPanel() {
    return this;
  }

  public String getName() {
    return name;
  }
}
