package jabba;

import com.sun.java.swing.table.AbstractTableModel;

class ViewerSingleLocationTabDataModel extends AbstractJabbaDataModel implements JabbaConstants {
  // glowny obiekt programu
  Jabba jabba;

  // magazyn danych
  Receiver receiver;

  // obslugiwana zakladka
  ViewerSingleLocationTab singleLocationTab;

  ViewerSingleLocationTabDataModel( Jabba jabba, ViewerSingleLocationTab tab ) {
    super();

    this.jabba = jabba;
    receiver = jabba.receiver;
    singleLocationTab = tab;

    jabba.console.addWriter( this, "viewer single location tab data model" );
  }

  public void single_location_descriptionChanged(int pos) {
    singleLocationTab.descriptionLabel.setText( receiver.getLocationDescription(pos) );
  }

  public void single_location_numberChanged(int pos) {
    singleLocationTab.numberLabel.setText( receiver.getLocationNumber(pos) );
  }

  public void single_location_phonesChanged(int pos) {
    singleLocationTab.phonesLabel.setText( receiver.getLocationPhones(pos) );
  }

  /**
   * @param user - index in LocationRecord list
   */
  public void single_location_personEntered(int userId) {
    TableSorter ts = (TableSorter)(singleLocationTab.peopleTable.getModel());
    SimpleTableModel model=(SimpleTableModel)(ts.getModel());

    model.addRow(userId);
  }

  /**
   * @param user - index in LocationRecord list
   */
  public void single_location_personLeft(int userId) {
    TableSorter ts = (TableSorter)(singleLocationTab.peopleTable.getModel());
    SimpleTableModel model=(SimpleTableModel)(ts.getModel());

    model.deleteRow(userId);
  }

}





