
#include "DO_ptr.h"
#include <rw/cstring.h>
#include <iostream.h>
#include "bootstrap_base.hh"
#include <string.h>

template <class T>
DO_ptr<T>::DO_ptr(T _my_object) :
  ior( CORBA::is_nil( _my_object) ? CORBA::string_dup("") :
       Bootstrap_base::orb->object_to_string( _my_object))
{
  my_object = _my_object;
  CORBA::Object::_duplicate(_my_object);
}

template <class T>
DO_ptr<T>::DO_ptr(const DO_ptr<T>& std) :
  ior( CORBA::string_dup( std.ior))
{
  my_object = std.my_object;
  CORBA::Object::_duplicate(std.my_object);
}

template <class T>
int DO_ptr<T>::operator == (const DO_ptr& sdo) const {
    T p1 = my_object;
    T p2 = sdo.my_object;
#ifdef ORBIX
    const char *p1_host= p1->_host(),
    *p2_host= p2->_host(),
    *p1_implementation= p1->_implementation(),
    *p2_implementation= p2->_implementation(),
    *p1_marker= p1->_marker(),
    *p2_marker= p2->_marker();

    if (p1_host && p2_host && p1_implementation && p2_implementation &&
	p1_marker && p2_marker) {
      
      if(strcmp(p1_host, p2_host)) return 0;
      if(strcmp(p1_implementation, p2_implementation)) return 0;
      if(strcmp(p1_marker, p2_marker)) return 0;
      return 1;
    }
    // one of the references is not an Orbix one
    //
    int is_eq= p1->_is_equivalent( p2);
    return is_eq;
#elif defined OMNIORB
    int is_eq= p1->_is_equivalent( p2);
    return is_eq;
#else
#error __FILE__ __LINE__
#endif
}

template <class T>
DO_ptr<T>& DO_ptr<T>::operator = (const DO_ptr<T>& sdo) {
  if(my_object != NULL) CORBA::release(my_object);
  my_object = sdo.my_object;
  CORBA::Object::_duplicate(sdo.my_object);
  ior= CORBA::string_dup( sdo.ior);
  return *this;
}
 
template <class T>     
DO_ptr<T>::~DO_ptr() {
  if(my_object != NULL) CORBA::release(my_object);
}


template <class T>
unsigned 
   hash_proxy(
	const DO_ptr<T>& observer_p
   )
{
#ifdef ORBIX
   T p1 = ((T)observer_p.my_object);

   const char *p1_host= p1->_host(),
     *p1_implementation= p1->_implementation(),
     *p1_marker= p1->_marker();

   if (p1_host && p1_implementation && p1_marker) {
     RWCString rwcString_1(p1_host);
     RWCString rwcString_2(p1_implementation);
     RWCString rwcString_3(p1_marker);

     RWCString rwcString_6(((T)observer_p.my_object)->_interfaceMarker());

     long i =  rwcString_1.hash() + rwcString_2.hash() + rwcString_3.hash(); 

     return i;
   }
   // it is not an Orbix reference

   return p1->_hash(117);

#elif defined OMNIORB
   return observer_p.my_object->_hash(117);
#endif
}




