//
//  File:         abng_string.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 28.01.98
//
// General Description:
//   Header file for the ABng_String class 
//

#ifndef abng_string_h
#define abng_string_h 

#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include <rw/regexp.h>
#include <rw/cstring.h>

#ifdef ORBIX
#include <CORBA.h>
#elif defined OMNIORB
#include <omniORB2/CORBA.h>
#endif


#ifdef ObjectStore
#include <oosa.h>
#endif

#ifdef FilePersistency
#include <fstream.h>
#endif

class ABng_String
{
 public:
   static char*
   copy_string(
	const char* data
   );

   static void 
   free_string(
	char* string_field
   );

  static int 
   match_string (
	const char* _string_pattern,
	const char* _string_field
   );

#ifdef FilePersistency

   static char* 
    read_string(
	istream &iostr
    );

#endif
};   

#endif /* abng_string_h */
