#ifdef OMNIORB

#include <omniORB2/CORBA.h>
#include <iostream.h>
#include <rw/cstring.h>
#include <stdlib.h>
#include "compatibility.hh"


#define PRINT_EXCEPTION(name) \
catch (CORBA::name) { \
			os << #name << endl; \
						 } 

ostream & operator <<( ostream &os, CORBA::Exception &ex) {
  try {
    throw;
  }
  PRINT_EXCEPTION (UNKNOWN)
  PRINT_EXCEPTION (BAD_PARAM)
  PRINT_EXCEPTION (NO_MEMORY)
  PRINT_EXCEPTION (IMP_LIMIT)
  PRINT_EXCEPTION (COMM_FAILURE)
  PRINT_EXCEPTION (INV_OBJREF)
  PRINT_EXCEPTION (OBJECT_NOT_EXIST)
  PRINT_EXCEPTION (NO_PERMISSION)
  PRINT_EXCEPTION (INTERNAL)
  PRINT_EXCEPTION (MARSHAL)
  PRINT_EXCEPTION (INITIALIZE)
  PRINT_EXCEPTION (NO_IMPLEMENT)
  PRINT_EXCEPTION (BAD_TYPECODE)
  PRINT_EXCEPTION (BAD_OPERATION)
  PRINT_EXCEPTION (NO_RESOURCES)
  PRINT_EXCEPTION (NO_RESPONSE)
  PRINT_EXCEPTION (PERSIST_STORE)
  PRINT_EXCEPTION (BAD_INV_ORDER)
  PRINT_EXCEPTION (TRANSIENT)
  PRINT_EXCEPTION (FREE_MEM)
  PRINT_EXCEPTION (INV_IDENT)
  PRINT_EXCEPTION (INV_FLAG)
  PRINT_EXCEPTION (INTF_REPOS)
  PRINT_EXCEPTION (BAD_CONTEXT)
  PRINT_EXCEPTION (OBJ_ADAPTER)
  PRINT_EXCEPTION (DATA_CONVERSION)
  PRINT_EXCEPTION (TRANSACTION_REQUIRED)
  PRINT_EXCEPTION (TRANSACTION_ROLLEDBACK)
  PRINT_EXCEPTION (INVALID_TRANSACTION)
  PRINT_EXCEPTION (WRONG_TRANSACTION)
    catch (CORBA::SystemException &ex) {
      os << "Unknown system exception" << endl;
    }
  catch (CORBA::UserException &ex) {
    os << "Unknown user exception" << endl;
  }
  catch (CORBA::Exception &ex) {
    os << "<<Exception>>" << endl;
  }
  return os;
}

void serialize_simpleAny( ostream &ostr, CORBA::Any *a) {
  
}

void serialize_TypeCode( ostream &ostr, CORBA::TypeCode_ptr tc) {
  switch (tc->kind()) {
  case CORBA::tk_null:
    ostr << "n "; break;
  case CORBA::tk_void:
    ostr << "v "; break;
  case CORBA::tk_short:
    ostr << "s "; break;
  case CORBA::tk_long:
    ostr << "l "; break;
  case CORBA::tk_ushort:
    ostr << "u "; break;
  case CORBA::tk_ulong:
    ostr << "L "; break;
  case CORBA::tk_float:
    ostr << "f "; break;
  case CORBA::tk_double:
    ostr << "d "; break;
  case CORBA::tk_boolean:
    ostr << "b "; break;
  case CORBA::tk_char:
    ostr << "c "; break;
  case CORBA::tk_octet:
    ostr << "o "; break;
  case CORBA::tk_any:
    ostr << "a "; break;
  case CORBA::tk_TypeCode:
    ostr << "T "; break;
  case CORBA::tk_Principal:
    ostr << "P "; break;
  case CORBA::tk_objref:
    ostr << "O " << tc->id() << ' ' << tc->name() << ' '; break;
  case CORBA::tk_struct:
    ostr << "R " << tc->id() << ' ' << tc->name() << ' ' << tc->member_count() << ' ' << endl;
    {
      for (int i=0; i<tc->member_count(); i++) {
	ostr << tc->member_name(i) << ' ';
	serialize_TypeCode( ostr, tc->member_type( i));
	ostr << endl;
      }
    }
    break;
  case CORBA::tk_union:
    ostr << "U " << tc->id() << ' ' << tc->name() << ' ' << tc->member_count() << ' ';
    serialize_TypeCode( ostr, tc->discriminator_type());
    ostr << endl;
    {
      for (int i=0; i<tc->member_count(); i++) {
	ostr << tc->member_name(i) << ' ';
	serialize_TypeCode( ostr, tc->member_type( i));
	serialize_simpleAny( ostr, tc->member_label( i));
	ostr << endl;
      }
    }
    break;
  case CORBA::tk_enum:
    ostr << "E " << tc->id() << ' ' << tc->name() << ' ' << tc->member_count() << ' ';
    {
      for (int i=0; i<tc->member_count(); i++)
	ostr << tc->member_name(i) << ' ';
      ostr << endl;
    }
    break;
  case CORBA::tk_string:
    ostr << "S " << tc->length() << ' '; break;
  case CORBA::tk_sequence:
    ostr << "Q " << tc->length() << ' ';
    serialize_TypeCode( ostr, tc->content_type());
    ostr << ' '; break;
  case CORBA::tk_array:
    ostr << "A " << tc->length() << ' ';
    serialize_TypeCode( ostr, tc->content_type());
    ostr << ' '; break;
  case CORBA::tk_alias:
    cerr << "Unimplemented serialization of TypeCode: tk_alias" << endl;
    exit( 1);
    ostr << "I " ; break;
  case CORBA::tk_except:
    ostr << "X " << tc->id() << ' ' << tc->name() << ' ' << tc->member_count() << ' ' << endl;
    {
      for (int i=0; i<tc->member_count(); i++) {
	ostr << tc->member_name(i) << ' ';
	serialize_TypeCode( ostr, tc->member_type( i));
	ostr << endl;
      }
    }
    break;
  }
}

void deserialize_TypeCode( istream &istr, CORBA::TypeCode_ptr &tc) {
  char tc_name;
  istr >> ws >> tc_name >> ws;
  if (!istr) return;
  switch (tc_name) {
  case 'n':
    tc= new CORBA::TypeCode( CORBA::tk_null); break;
  case 'v':
    tc= new CORBA::TypeCode( CORBA::tk_void); break;
  case 's':
    tc= new CORBA::TypeCode( CORBA::tk_short); break;
  case 'l':
    tc= new CORBA::TypeCode( CORBA::tk_long); break;
  case 'u':
    tc= new CORBA::TypeCode( CORBA::tk_ushort); break;
  case 'L':
    tc= new CORBA::TypeCode( CORBA::tk_ulong); break;
  case 'f':
    tc= new CORBA::TypeCode( CORBA::tk_float); break;
  case 'd':
    tc= new CORBA::TypeCode( CORBA::tk_double); break;
  case 'b':
    tc= new CORBA::TypeCode( CORBA::tk_boolean); break;
  case 'c':
    tc= new CORBA::TypeCode( CORBA::tk_char); break;
  case 'o':
    tc= new CORBA::TypeCode( CORBA::tk_octet); break;
  case 'a':
    tc= new CORBA::TypeCode( CORBA::tk_any); break;
  case 'T':
    tc= new CORBA::TypeCode( CORBA::tk_TypeCode); break;
  case 'P':
    tc= new CORBA::TypeCode( CORBA::tk_Principal); break;
  case 'O':
    {
      RWCString id,name;
      istr >> id >> name;
      tc= new CORBA::TypeCode( (const char *) id, (const char *) name);
    }
    break;
      
  case 'R':
  case 'U':
  case 'E':
    cerr << "Unimplemented TypeCode: compatibility.cc:deserialize_TypeCode (1)" << endl;
    exit(1);
    break;
  case 'S':
    {
      unsigned len;
      istr >> len;
      tc= new CORBA::TypeCode( CORBA::tk_string, len);
    }
    break;
  case 'Q':
    {
      unsigned len;
      istr >> len;
      CORBA::TypeCode_ptr content;
      deserialize_TypeCode( istr, content);
      tc= new TypeCode( CORBA::tk_sequence, len, *content);
    }
    break;
  case CORBA::tk_array:
    {
      unsigned len;
      istr >> len;
      CORBA::TypeCode_ptr content;
      deserialize_TypeCode( istr, content);
      tc= new TypeCode( CORBA::tk_array, len, *content);
    }
    break;
  case 'I':
  case 'X':
    cerr << "Unimplemented TypeCode: compatibility.cc:deserialize_TypeCode (2)" << endl;
    exit(1);
    break;
  default:
    cerr << "Unimplemented TypeCode: compatibility.cc:deserialize_TypeCode (2)" << endl;
    exit(1);
    break;
  }
}

#elif defined(ORBIX) // OMNIORB

#define EXCEPTIONS
#include <CORBA.h>
#include <iostream.h>

CORBA::Boolean DII_non_existent( CORBA::Object_ptr obj) {
  CORBA::Request_var r;
  CORBA::Boolean res= 0;

  try {
    r= CORBA::Request:: IT_create (obj);
  }
  catch (CORBA::Exception &ex) {
    cerr << ex << endl;
    return 0;
  }
  try {
    r->setOperation("_non_existent");
    r->set_return_type(CORBA::_tc_boolean);
  }
  catch (CORBA::Exception &ex) {
    cerr << ex << endl;
    return 0;
  }
  //  cerr << "request created, sending..." << endl;
  try {
    r->invoke ();
    (* (r.operator->())) >> res;
  } catch (CORBA::BAD_OPERATION &ex2) {
    return 0;
  } catch (CORBA::COMM_FAILURE &ex3) {
    return 1;
  } catch ( CORBA::Exception &ex) {
    //    cerr << ex << endl;
    return 1;
  }
  return res;
}

#endif // ORBIX

//

