// $Id: rep_client.h,v 1.1 1998/06/16 12:56:16 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/common/rep_client.h,v $
//
// $Log: rep_client.h,v $
// Revision 1.1  1998/06/16 12:56:16  mencnar
// Initial revision
//
//
// File:          rep_client.h
// Author:        Malgorzata Steinder (gosia@ics.agh.edu.pl)
// Date Created:  16.03.98
//
// General Description:
//  Declaration of the Rep_Client class which is a skeleton for ABng 
//  repository utilities.

#include "basic_client.h"

template<class Repository_Types>
class Rep_Client : public Basic_Client<Repository_Types> {

public:

  typedef Repository_Types::Repository_Manager Repository_Manager;
  typedef Repository_Types::Repository_Manager_ptr Repository_Manager_ptr;

  Rep_Client(resolve_fun f, resolve_fun f_mgr) 
    : Basic_Client<Repository_Types>(f), srv_rep_mgr(f_mgr) {}

  virtual ~Rep_Client() {
      if(operation) delete operation;
      if(prog_name) delete prog_name;
  }

  typedef char* Parameters[20];

  struct _Operation {
          char* name;
          Parameters parameters;
  };

  typedef _Operation Operations[20];

  static Operations operations;
  static char* description;

  virtual void init(int argc, char **argv);
  virtual void init_fields(int argc, char **argv);
  virtual void init_rep_ptr();
  
  virtual void run();
  virtual void get_options(int argc, char **argv);
  virtual void find();
  virtual void find_values();
  virtual void add(char* data1);
  virtual void remove(char* data1);
  virtual void update(char* data2, char* data1);

  virtual void other_operations() {}

  virtual Initial_Data init_data(char* data) = 0;

  virtual void print_info();

  virtual char*               read_id(char*& data);
  virtual CORBA::TypeCode_ptr read_TC(char*& data);
  virtual void                skip_digits(char*& data);
  virtual short               read_short(char*& data);
  virtual long                read_long(char*& data);
  virtual unsigned short      read_ushort(char*& data);
  virtual unsigned long       read_ulong(char*& data);
  virtual float               read_float(char*& data);
  virtual double              read_double(char*& data);
  virtual char                read_char(char*& data);
  virtual unsigned char       read_octet(char*& data);
  virtual char*               read_string(char*& data);
  virtual void                read_spaces(char*& data);
  virtual unsigned char       read_boolean(char*& data);
  virtual void*               read_void(CORBA::TypeCode_ptr tc, char*& data);

protected:

  char *prog_name;
  int ior_flag;
  char* operation;
  char** my_argv;
  int my_argc;

  Repository_Manager_ptr my_rep_mgr;

  resolve_fun srv_rep_mgr;


};


