// $Id: rep_server.h,v 1.2 1998/07/29 13:14:55 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/common/rep_server.h,v $
//
// $Log: rep_server.h,v $
// Revision 1.2  1998/07/29 13:14:55  mencnar
// time synchronisation,
// persistent observers,
// notify calls moved to another thread ( fixed deadlock)
// internal server names changed
//
// Revision 1.1  1998/06/16 12:56:16  mencnar
// Initial revision
//
//
// File:          rep_server.h
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  02.02.98
//
// General Description:
//  Declaration of the Rep_Server class which is a skeleton for ABng 
//  repository servers.

#ifndef __REP_SERVER_H__
#define __REP_SERVER_H__

#include "basic_server.h"

#ifdef ObjectStore
#include <oosa.h>
#endif /* ObjectStore */

class Rep_Server : public Basic_Server {

public:

  Rep_Server(
#ifdef ObjectStore
    const char *db_name_p, // default db name
#elif FilePersistency
    const char *file_name_p, // default db name
#endif
    const char *current_directory_p = ".");

  virtual ~Rep_Server();

  virtual void init(int argc, char **argv);
  virtual void final();
  virtual void get_options(int argc, char **argv);
  virtual void check_directory(const char *dir_name_p);
  virtual char *concat_path_name(const char *dir_name_p, 
    const char *file_name_p);
  virtual void print_info();

#ifdef ObjectStore
  virtual os_database * init_os();  
#endif /* ObjectStore */
  virtual void create_objects() = 0;
  virtual void delete_objects() = 0;

protected:

#ifdef ObjectStore
  char *my_db_name;
#elif FilePersistency
  char *file_name;
#endif /* ObjectStore */
  char *my_current_directory;
  int cold_start;
  char *prog_name;
};

#endif  // __REP_SERVER_H__

//
