//
// $Id: Bootstrap_n.java,v 1.2 1998/07/29 13:25:05 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/common_java/all/Bootstrap_n.java,v $
//
// $Log: Bootstrap_n.java,v $
// Revision 1.2  1998/07/29 13:25:05  mencnar
// minor bug fixes in Visibroker 3.2 port
//
//

// 
package pl.edu.agh.ics.abngcore;


public class Bootstrap_n {
  private static Bootstrap_base base= null;
  private static ABng_Server_Manager.Register register_object;
  private static ABng_Server_Manager.Register_Manager register_manager_object= null;

  public static void init() {
    init( false);
  }

  public static void init( java.net.URL url) {
    if ( base != null) return;

    base= new Bootstrap_base( url);
    try {
      register_object= ABng_Server_Manager.RegisterHelper.narrow(
				 resolve( SRV_Bootstrap_Client()));
    }
    catch ( Exception ex) {
      System.err.println("Could not contact ABng_Server_Manager::Register object "+ex);
      System.exit( 1);
    }
  }

  public static void init( boolean client_only) {
    if ( base != null) return;

    base= new Bootstrap_base();
    try {
      register_object= ABng_Server_Manager.RegisterHelper.narrow(
				 resolve( SRV_Bootstrap_Client()));
      if (!client_only)
	register_manager_object= ABng_Server_Manager.
	  Register_ManagerHelper.narrow( resolve( SRV_Bootstrap()));
    }
    catch ( Exception ex) {
      System.err.println("Could not contact ABng_Server_Manager::Register object "+ex);
      System.exit( 1);
    }
  }

  public static ABng_Server_Manager.Register get_register_object() {
    return register_object;
  }
  
  public static ABng_Server_Manager.Register_Manager get_register_manager_object() {
    return register_manager_object;
  }

  public static void register_server_in_NS( String[] name,
					    org.omg.CORBA.Object server_ref) 
       throws ABng_Server_Manager.Invalid_Server_Name,
              ABng_Server_Manager.Server_Still_Active,
              ABng_Server_Manager.Invalid_Server_Reference 
  {
    if (register_manager_object == null) {
      System.err.println("A client cannot register a server");
      System.exit(1);
    }
    register_manager_object.register_server( server_ref,
					     name);
  }

  public static void unregister_server_from_NS( String[] name) 
       throws ABng_Server_Manager.Invalid_Server_Name,
              ABng_Server_Manager.Unknown_Server_Name {
    if (register_manager_object == null) {
      System.err.println("A client cannot unregister a server");
      System.exit(1);
    }
    register_manager_object.unregister_server( name);
  }

  public static org.omg.CORBA.Object resolve( String[] name) 
        throws org.omg.CosNaming.NamingContextPackage.NotFound,
               org.omg.CosNaming.NamingContextPackage.InvalidName, 
               org.omg.CosNaming.NamingContextPackage.CannotProceed {
    return base.resolve( name);
  }

  public static String[] concat_names( String[] name1, String[] name2) {
    String[] ret= new String[ name1.length + name2.length];
    for ( int i=0; i<ret.length; i++)
      ret[ i]= (i<name1.length) ? name1[ i] :
                                  name2[ i-name1.length];
    return ret;
  }

  public static String[] concat_names( String[] name1, String name2) {
    return concat_names( name1, new String[] { name2} );
  }

  public static boolean name_in_context( String[] name, String[] context) {
    if ( name.length >= context.length) {
      for ( int i=0; i<context.length; i++)
	if ( ! name[ i].equals( context[ i])) return false;
      return true;
    }
    return false;
  }

  public static boolean equal_names( String[] name1, String[] name2) {
    if ( name1.length == name2.length) {
      for ( int i=0; i<name1.length; i++)
	if ( ! name1[ i].equals( name2[ i])) return false;
      return true;
    }
    return false;
  }

  private static String[] _CTX_Root= new String[ 0];
  public static String[] CTX_Root() {
    return _CTX_Root;
  }

  private static String[] _CTX_ABng=
     concat_names( CTX_Root(), "ABng");
  public static String[] CTX_ABng() {
    return _CTX_ABng;
  }

  private static String[] _CTX_Bootstrap_Client=
     concat_names( CTX_ABng(), "Bootstrap_Client");
  public static String[] CTX_Bootstrap_Client() {
    return _CTX_Bootstrap_Client;
  }

  private static String[] _CTX_Domain_Repository= 
     concat_names( CTX_ABng(), "Domain_Repository");
  public static String[] CTX_Domain_Repository() {
    return _CTX_Domain_Repository;
  }

  private static String[] _CTX_Domain_Repository_Public=
    concat_names( CTX_Domain_Repository(), "Public");
  public static String[] CTX_Domain_Repository_Public() {
    return _CTX_Domain_Repository_Public;
  }

  private static String[] _CTX_Domain_Repository_Management=
    concat_names( CTX_Domain_Repository(), "Management");
  public static String[] CTX_Domain_Repository_Management() {
    return _CTX_Domain_Repository_Management;
  }

  private static String[] _CTX_ABng_Core=
    concat_names( CTX_ABng(), "ABng_Core");
  public static String[] CTX_ABng_Core() {
    return _CTX_ABng_Core;
  }

  private static String[] _CTX_ABng_Core_Public=
    concat_names( CTX_ABng_Core(), "Public");
  public static String[] CTX_ABng_Core_Public() {
    return _CTX_ABng_Core_Public;
  }

  private static String[] _CTX_ABng_Core_Public_Views=
    concat_names( CTX_ABng_Core_Public(), "Views");
  public static String[] CTX_ABng_Core_Public_Views() {
    return _CTX_ABng_Core_Public_Views;
  }

  private static String[] _CTX_ABng_Core_Management=
    concat_names( CTX_ABng_Core(), "Management");
  public static String[] CTX_ABng_Core_Management() {
    return _CTX_ABng_Core_Management;
  }

  private static String[] _CTX_ABng_Core_System=
    concat_names( CTX_ABng_Core(), "System");
  public static String[] CTX_ABng_Core_System() {
    return _CTX_ABng_Core_System;
  }

  private static String[] _CTX_ABng_Core_System_Pollers=
    concat_names( CTX_ABng_Core_System(), "Pollers");
  public static String[] CTX_ABng_Core_System_Pollers() {
    return _CTX_ABng_Core_System_Pollers;
  }

  private static String[] _CTX_ABng_Core_System_Vsps=
    concat_names( CTX_ABng_Core_System(), "Vsps");
  public static String[] CTX_ABng_Core_System_Vsps() {
    return _CTX_ABng_Core_System_Vsps;
  }

  private static String[] _CTX_ABng_Core_Management_View_Managers=
    concat_names( CTX_ABng_Core_Management(), "View_Managers");
  public static String[] CTX_ABng_Core_Management_View_Managers() {
    return _CTX_ABng_Core_Management_View_Managers;
  }

  private static String[] _SRV_Bootstrap=
    concat_names( CTX_ABng(), "Bootstrap@");
  public static String[] SRV_Bootstrap() {
    return _SRV_Bootstrap;
  }

  private static String[] _SRV_Bootstrap_Client=
    concat_names( CTX_Bootstrap_Client(), "Client");
  public static String[] SRV_Bootstrap_Client() {
    return _SRV_Bootstrap_Client;
  }

  private static String[] _SRV_Scheduler=
    concat_names( CTX_ABng_Core_System(), "Scheduler@");
  public static String[] SRV_Scheduler() {
    return _SRV_Scheduler;
  }

  private static String[] _SRV_Sensor_Repository=
    concat_names( CTX_ABng_Core_Management(), "Sensor_Repository@");
  public static String[] SRV_Sensor_Repository() {
    return _SRV_Sensor_Repository;
  }

  private static String[] _SRV_Badge_Repository=
    concat_names( CTX_ABng_Core_Management(), "Badge_Repository@");
  public static String[] SRV_Badge_Repository() {
    return _SRV_Badge_Repository;
  }

  private static String[] _SRV_Badge_Holder_Repository=
    concat_names( CTX_ABng_Core_Management(), "Badge_Holder_Repository@");
  public static String[] SRV_Badge_Holder_Repository() {
    return _SRV_Badge_Holder_Repository;
  }

  private static String[] _SRV_Away_Repository=
    concat_names( CTX_ABng_Core_Public(), "Away_Repository");
  public static String[] SRV_Away_Repository() {
    return _SRV_Away_Repository;
  }

  private static String[] _SRV_Away_Repository_Manager=
    concat_names( CTX_ABng_Core_Management(), "Away_Repository_Manager@");
  public static String[] SRV_Away_Repository_Manager() {
    return _SRV_Away_Repository_Manager;
  }

  private static String[] _SRV_Location_Type_Repository=
    concat_names( CTX_Domain_Repository_Public(), "Location_Type_Repository");
  public static String[] SRV_Location_Type_Repository() {
    return _SRV_Location_Type_Repository;
  }

  private static String[] _SRV_Location_Type_Repository_Manager=
    concat_names( CTX_Domain_Repository_Management(), "Location_Type_Repository_Manager@");
  public static String[] SRV_Location_Type_Repository_Manager() {
    return _SRV_Location_Type_Repository_Manager;
  }
  
  private static String[] _SRV_Location_Description_Repository=
    concat_names( CTX_Domain_Repository_Public(), "Location_Description_Repository");
  public static String[] SRV_Location_Description_Repository() {
    return _SRV_Location_Description_Repository;
  }
  
  private static String[] _SRV_Location_Description_Repository_Manager=
    concat_names( CTX_Domain_Repository_Management(), "Location_Description_Repository_Manager@");
  public static String[] SRV_Location_Description_Repository_Manager() {
    return _SRV_Location_Description_Repository_Manager;
  }

  private static String[] _SRV_ABng_Location_Description_Repository=
    concat_names( CTX_ABng_Core_Management(), "ABng_Location_Description_Repository@");
  public static String[] SRV_ABng_Location_Description_Repository() {
    return _SRV_ABng_Location_Description_Repository;
  }

  private static String[] _SRV_User_Repository=
    concat_names( CTX_Domain_Repository_Public(), "User_Repository");
  public static String[] SRV_User_Repository() {
    return _SRV_User_Repository;
  }
  
  private static String[] _SRV_User_Repository_Manager=
    concat_names( CTX_Domain_Repository_Management(), "User_Repository_Manager@");
  public static String[] SRV_User_Repository_Manager() {
    return _SRV_User_Repository_Manager;
  }

  private static String[] _SRV_Meta_Equipment_Repository=
    concat_names( CTX_Domain_Repository_Public(), "Meta_Equipment_Repository");
  public static String[] SRV_Meta_Equipment_Repository() {
    return _SRV_Meta_Equipment_Repository;
  }

  private static String[] _SRV_Meta_Equipment_Repository_Manager=
    concat_names( CTX_Domain_Repository_Management(), "Meta_Equipment_Repository_Manager@");
  public static String[] SRV_Meta_Equipment_Repository_Manager() {
    return _SRV_Meta_Equipment_Repository_Manager;
  }

  private static String[] _SRV_Equipment_Repository=
    concat_names( CTX_Domain_Repository_Public(), "Equipment_Repository");
  public static String[] SRV_Equipment_Repository() {
    return _SRV_Equipment_Repository;
  }
  
  private static String[] _SRV_Equipment_Repository_Manager=
    concat_names( CTX_Domain_Repository_Management(), "Equipment_Repository_Manager@");
  public static String[] SRV_Equipment_Repository_Manager() {
    return _SRV_Equipment_Repository_Manager;
  }


}


