//
// $Id: RepTools.java,v 1.1 1998/07/29 13:25:06 mencnar Exp $
//
// $Log: RepTools.java,v $
// Revision 1.1  1998/07/29 13:25:06  mencnar
// minor bug fixes in Visibroker 3.2 port
//
//
//

package pl.edu.agh.ics.abngcore;

public class RepTools {
  private static Domain_Repository.Boolean_Pattern get_boolean_pattern() {
    Domain_Repository.Boolean_Pattern bp=
      new Domain_Repository.Boolean_Pattern();
    bp.is_any= true;
    bp.value= false;
    return bp;
  }

  private static Domain_Repository.String_Pattern get_string_pattern() {
    Domain_Repository.String_Pattern sp=
      new Domain_Repository.String_Pattern();
    sp.is_any= true;
    sp.value= "";
    return sp;
  }

  private static Domain_Repository.Unsigned_Long_Pattern get_ulong_pattern() {
    Domain_Repository.Unsigned_Long_Pattern ulp=
      new Domain_Repository.Unsigned_Long_Pattern();
    ulp.is_any= true;
    ulp.value= 0;
    return ulp;
  }

  private static Domain_Repository.Unsigned_Short_Pattern get_ushort_pattern() {
    Domain_Repository.Unsigned_Short_Pattern ulp=
      new Domain_Repository.Unsigned_Short_Pattern();
    ulp.is_any= true;
    ulp.value= 0;
    return ulp;
  }

  private static Domain_Repository.Octets_Pattern get_octets_pattern() {
    Domain_Repository.Octets_Pattern ocp=
      new Domain_Repository.Octets_Pattern();
    ocp.is_any= true;
    ocp.value= new byte[0];
    return ocp;
  }

  private static Domain_Repository.Time_Pattern get_time_pattern() {
    Domain_Repository.Time_Pattern tp=
      new Domain_Repository.Time_Pattern();
    tp.is_any= true;
    tp.before= false;
    tp.value= new Domain_Repository.Time();
    tp.value.seconds= tp.value.microseconds= 0;
    return tp;
  }

  public static Domain_Repository.UserPackage.Pattern get_urep_pattern() {
    Domain_Repository.UserPackage.Pattern upatt=
      new Domain_Repository.UserPackage.Pattern();
    upatt.is_any= true;
    upatt.item_id_pattern= get_ulong_pattern();
    upatt.uid_pattern= get_string_pattern();
    upatt.forename_pattern= get_string_pattern();
    upatt.surname_pattern= get_string_pattern();
    upatt.position_pattern= get_string_pattern();
    upatt.email_pattern= get_string_pattern();
    upatt.phone_pattern= get_string_pattern();
    return upatt;
  }

  public static Domain_Repository.Location_TypePackage.Pattern get_ltrep_pattern() {
    Domain_Repository.Location_TypePackage.Pattern ltpatt=
      new Domain_Repository.Location_TypePackage.Pattern();
    ltpatt.is_any= true;
    ltpatt.item_id_pattern= get_ulong_pattern();
    ltpatt.name_pattern= get_string_pattern();
    ltpatt.property_description_list_pattern=
      new Domain_Repository.Property_Descriptions_Pattern();
    ltpatt.property_description_list_pattern.is_any= true;
    ltpatt.property_description_list_pattern.constraints=
      Domain_Repository.Sequence_Pattern_Constraints.UNRESTRICTED;
    ltpatt.property_description_list_pattern.value=
      new Domain_Repository.Property_Description_Pattern[0];
    return ltpatt;
  }
  
  public static Domain_Repository.Location_DescriptionPackage.Pattern get_ldrep_pattern() {
    Domain_Repository.Location_DescriptionPackage.Pattern ldpatt=
      new Domain_Repository.Location_DescriptionPackage.Pattern();
    ldpatt.is_any= true;
    ldpatt.item_id_pattern= get_ulong_pattern();
    ldpatt.type_name_pattern= get_string_pattern();
    ldpatt.property_list_pattern=
      new Domain_Repository.Properties_Pattern();
    ldpatt.property_list_pattern.is_any= true;
    ldpatt.property_list_pattern.constraints=
      Domain_Repository.Sequence_Pattern_Constraints.UNRESTRICTED;
    ldpatt.property_list_pattern.value=
      new Domain_Repository.Property_Pattern[0];
    return ldpatt;
  }

  public static Domain_Repository.Meta_EquipmentPackage.Pattern get_merep_pattern() {
    Domain_Repository.Meta_EquipmentPackage.Pattern mepatt=
      new Domain_Repository.Meta_EquipmentPackage.Pattern();
    mepatt.is_any= true;
    mepatt.item_id_pattern= get_ulong_pattern();
    mepatt.type_pattern= get_string_pattern();
    mepatt.vendor_pattern= get_string_pattern();
    mepatt.model_pattern= get_string_pattern();
    mepatt.my_dimensions_pattern=
      new Domain_Repository.Meta_EquipmentPackage.Dimensions_Pattern();
    mepatt.my_dimensions_pattern.is_any= true;
    mepatt.my_dimensions_pattern.height_pattern= get_ulong_pattern();
    mepatt.my_dimensions_pattern.width_pattern= get_ulong_pattern();
    mepatt.my_dimensions_pattern.depth_pattern= get_ulong_pattern();
    mepatt.my_control_info_pattern=
      new Domain_Repository.Meta_EquipmentPackage.Control_Info_Pattern();
    mepatt.my_control_info_pattern.is_any= true;
    mepatt.my_control_info_pattern.my_control_data_pattern=
      new Domain_Repository.Meta_EquipmentPackage.Control_Info_PatternPackage.
        IRCI_Pattern();
    mepatt.my_control_info_pattern.my_control_data_pattern.default_field_pattern( get_ulong_pattern());
    mepatt.specific_property_description_list_pattern=
      new Domain_Repository.Property_Descriptions_Pattern();
    mepatt.specific_property_description_list_pattern.is_any= true;
    mepatt.specific_property_description_list_pattern.constraints=
      Domain_Repository.Sequence_Pattern_Constraints.UNRESTRICTED;
    mepatt.specific_property_description_list_pattern.value=
      new Domain_Repository.Property_Description_Pattern[0];
    mepatt.my_icon_pattern= get_octets_pattern();
      
    return mepatt;
  }

  public static Domain_Repository.EquipmentPackage.Pattern get_erep_pattern() {
    Domain_Repository.EquipmentPackage.Pattern epatt=
      new Domain_Repository.EquipmentPackage.Pattern();
    epatt.is_any= true;
    epatt.item_id_pattern= get_ulong_pattern();
    epatt.meta_data_pattern= get_merep_pattern();
    epatt.name_pattern= get_string_pattern();
    epatt.last_command_pattern= get_string_pattern();
    epatt.property_list_pattern=
      new Domain_Repository.Properties_Pattern();
    epatt.property_list_pattern.is_any= true;
    epatt.property_list_pattern.constraints=
      Domain_Repository.Sequence_Pattern_Constraints.UNRESTRICTED;
    epatt.property_list_pattern.value=
      new Domain_Repository.Property_Pattern[0];
    
    return epatt;
  }

  public static ABng_Core.AwayPackage.Pattern get_arep_pattern() {
    ABng_Core.AwayPackage.Pattern apatt=
      new ABng_Core.AwayPackage.Pattern();
    apatt.is_any= true;
    apatt.item_id_pattern= get_ulong_pattern();
    apatt.type_specific_object_pattern=
      new ABng_Core.Locatable_Type_Specific_Object_Pattern();
    apatt.type_specific_object_pattern.is_any= true;
    apatt.type_specific_object_pattern.object_pattern=
      new ABng_Core.Locatable_Type_Specific_Object_PatternPackage.Ref_Pattern();
    apatt.type_specific_object_pattern.object_pattern.user_obj_pattern(
						   get_urep_pattern());
    apatt.start_time_pattern= get_time_pattern();
    apatt.stop_time_pattern= get_time_pattern();
    apatt.cancel_from_time_pattern= get_time_pattern();
    apatt.message_pattern= get_string_pattern();
    apatt.contact_pattern= get_string_pattern();
    apatt.cancel_by_badge_pattern= get_boolean_pattern();
    apatt.active_pattern= get_boolean_pattern();

    return apatt;
  }

  public static ABng_Core_System.SensorPackage.Pattern get_srep_pattern() {
    ABng_Core_System.SensorPackage.Pattern spatt=
      new ABng_Core_System.SensorPackage.Pattern();
    spatt.is_any= true;
    spatt.item_id_pattern= get_ulong_pattern();
    spatt.id_pattern= new ABng_Core_System.Sensor_Id_Pattern();
    spatt.id_pattern.is_any= true;
    spatt.id_pattern.sensor_num_pattern= get_ushort_pattern();
    spatt.id_pattern.network_num_pattern= get_ushort_pattern();
    spatt.id_pattern.network_grp_name_pattern= get_string_pattern();
    return spatt;
  }

  public static ABng_Core_System.BadgePackage.Pattern get_brep_pattern() {
    ABng_Core_System.BadgePackage.Pattern bpatt=
      new ABng_Core_System.BadgePackage.Pattern();
    bpatt.is_any= true;
    bpatt.item_id_pattern= get_ulong_pattern();
    bpatt.id_pattern= get_octets_pattern();
    return bpatt;
  }

  public static ABng_Core_System._Badge_HolderPackage.Pattern get_bhrep_pattern() {
    ABng_Core_System._Badge_HolderPackage.Pattern bhpatt=
      new ABng_Core_System._Badge_HolderPackage.Pattern();
    bhpatt.is_any= true;
    bhpatt.item_id_pattern= get_ulong_pattern();
    bhpatt.my_badge_pattern= get_brep_pattern();
    bhpatt.current_badge_pattern= get_brep_pattern();
    bhpatt.home_sensor_pattern= get_srep_pattern();
    bhpatt.type_specific_object_pattern=
      new ABng_Core.Locatable_Type_Specific_Object_Pattern();
    bhpatt.type_specific_object_pattern.is_any= true;
    bhpatt.type_specific_object_pattern.object_pattern=
      new ABng_Core.Locatable_Type_Specific_Object_PatternPackage.Ref_Pattern();
    bhpatt.type_specific_object_pattern.object_pattern.user_obj_pattern(
						   get_urep_pattern());

    bhpatt.assigned_pattern= get_boolean_pattern();
    bhpatt.visitor_pattern= get_boolean_pattern();
    return bhpatt;
  }

  public static ABng_Core_System.ABng_Location_DescriptionPackage.Pattern get_aldrep_pattern() {
    ABng_Core_System.ABng_Location_DescriptionPackage.Pattern aldpatt=
      new ABng_Core_System.ABng_Location_DescriptionPackage.Pattern();
    aldpatt.is_any= true;
    aldpatt.item_id_pattern= get_ulong_pattern();
    aldpatt.loc_descr_pattern= get_ldrep_pattern();
    aldpatt.sensor_list_pattern=
      new ABng_Core_System.SensorPackage.Sensors_Pattern();
    aldpatt.sensor_list_pattern.is_any= true;
    aldpatt.sensor_list_pattern.constraints=
      Domain_Repository.Sequence_Pattern_Constraints.UNRESTRICTED;
    aldpatt.sensor_list_pattern.sensors_pattern=
      new ABng_Core_System.SensorPackage.Pattern[0];
    return aldpatt;
  }

  public static ABng_Core.LocatablePackage.Pattern get_locatable_pattern() {
    ABng_Core.LocatablePackage.Pattern lpatt=
      new ABng_Core.LocatablePackage.Pattern();
    lpatt.is_any= true;
    lpatt.item_id_pattern= get_ulong_pattern();
    lpatt.home_location_pattern= get_location_pattern();
    lpatt.type_specific_object_pattern=
      new ABng_Core.Locatable_Type_Specific_Object_Pattern();
    lpatt.type_specific_object_pattern.is_any= true;
    lpatt.type_specific_object_pattern.object_pattern=
      new ABng_Core.Locatable_Type_Specific_Object_PatternPackage.Ref_Pattern();
    lpatt.type_specific_object_pattern.object_pattern.user_obj_pattern(
						   get_urep_pattern());
    lpatt.assigned_pattern= get_boolean_pattern();
    lpatt.visitor_pattern= get_boolean_pattern();
    return lpatt;
  }

  public static ABng_Core.LocationPackage.Pattern get_location_pattern() {
    ABng_Core.LocationPackage.Pattern lpatt=
      new ABng_Core.LocationPackage.Pattern();
    lpatt.is_any= true;
    lpatt.item_id_pattern= get_ulong_pattern();
    lpatt.loc_descr_pattern= get_ldrep_pattern();
    return lpatt;
  }
}

