//
//  File:         abng_location_descr_rep_observer_i.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 16.12.97
//
// General Description:
//   Header file for the implementation class of the Observer of 
//	the Location_Descr Repositoryinterface
//

#ifndef Location_Descr_Observer_i_h
#define Location_Descr_Observer_i_h

#include <stdio.h>
#include <fstream.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include "abng_location_descr_rep_i.h"

class Location_Descr_Observer_I  {

  static Location_Descr_Observer_I* _instance;

 public:
   // ctor
  Location_Descr_Observer_I ();

  virtual 
   ~Location_Descr_Observer_I ();

  // reference of CORBA object encapsulated this C++ object
  Domain_Repository::Static_Data_Observer_ptr my_corba_object;

  static Location_Descr_Observer_I* instance() { return _instance; }


  //
  // IDL operations of the Static_Data_Observer interface
  //                       ___________________________
            
  virtual void 
   notify (
        Domain_Repository::Repository_Item_Id id,
	const Domain_Repository::Static_Data_Observer::Static_Data_Object& sd, 
	Domain_Repository::Change_Type change
        ENV_DECL(env)

   );

  virtual void 
   abort (
		ENV_DECL1(env)
   );
  
  void reference_resolved(const ABng_Server_Manager::Name &name,
			  CORBA::Object_var server_ref);

protected:
			  
  Domain_Repository::Location_Description_Rep_ptr location_descr_rep;
};   

#ifdef ORBIX
DEF_TIE_Domain_Repository_Static_Data_Observer(Location_Descr_Observer_I)
#elif defined OMNIORB
// DEF_TIE__tie_Static_Data_Observer
#endif

#endif /* Location_Descr_Observer_i_h */
