//
//  File:         badge_holder_rep_server.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 05.02.98
//
// General Description:
//   Header file of the Badge_Holder_Rep_Server class
//

#ifndef badge_holder_rep_server_i_h
#define badge_holder_rep_server_i_h 1

#include "rep_server.h"
#include "badge_holder_rep_i.h"

class Badge_Holder_Rep_Server : public Rep_Server {

public:
   Badge_Holder_Rep_Server(
#ifdef ObjectStore
    	const char *db_name_p = "dbName",
#elif FilePersistency
    	const char *file_name_p = "Badge_Holder_Rep.db",
#endif
    	const char *current_directory_p = "."
    ) : Rep_Server (
#ifdef ObjectStore
    		db_name_p,
#elif FilePersistency
   		 file_name_p,
#endif
    		current_directory_p
        ) {}

  virtual 
    ~Badge_Holder_Rep_Server() {}

  virtual void 
    create_objects();

  virtual void 
    delete_objects();

protected:
   Badge_Holder_Rep_I *my_rep_i;
};

#endif /* badge_holder_rep_server_i_h */





