//
//  File:         badge_rep_observer_i.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 04.03.98
//
// General Description:
//   Header file for the implementation class of the Observer of 
//	the Badge Repository interface
//

#ifndef badge_rep_observer_i_h
#define badge_rep_observer_i_h

#include <stdio.h>
#include <fstream.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include "badge_rep_i.h"

class Badge_Rep_Observer_I  {

  static Badge_Rep_Observer_I* _instance;

 public:
   // ctor
  Badge_Rep_Observer_I ();

  virtual 
   ~Badge_Rep_Observer_I ();

  // reference of CORBA object encapsulated this C++ object
  Domain_Repository::Static_Data_Observer_ptr my_corba_object;

  static Badge_Rep_Observer_I* instance() { return _instance; }


  //
  // IDL operations of the Static_Data_Observer interface
  //                       ____________________
            
  virtual void 
   notify (
	Domain_Repository::Repository_Item_Id id,
	const Domain_Repository::Static_Data_Observer::Static_Data_Object& sd, 
	Domain_Repository::Change_Type change,
	CORBA::Environment &IT_env=CORBA::default_environment
   );

  virtual void 
   abort (
	CORBA::Environment &IT_env=CORBA::default_environment
   );
  
protected:
			  
  Domain_Repository::Location_Description_Rep_ptr location_descr_rep;
};   

DEF_TIE_Domain_Repository_Static_Data_Observer(Badge_Rep_Observer_I)

#endif /* badge_rep_observer_i_h */
