// $Id: comparable_sensor_descr.h,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/comparable_sensor_descr.h,v $
//
// $Log: comparable_sensor_descr.h,v $
// Revision 1.1.1.1  1998/06/18 13:37:37  mencnar
//
// Revision 1.1  1998/03/06 13:46:30  jasz
// Initial revision
//
//
// File:          comparable_sensor_descr.h
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  26.01.98
//
// General Description:
//  Declaration of the Comparable_Sensor_Descr class. It encapsulates sensor 
//  data and provides an equality testing operator.

#ifndef __COMPARABLE_SENSOR_DESCR_H__
#define __COMPARABLE_SENSOR_DESCR_H__

#include "abng_core_management.hh"

class Comparable_Sensor_Descr : public ABng_Core_System::Sensor::Description {

public:

  Comparable_Sensor_Descr();
  Comparable_Sensor_Descr(
    const ABng_Core_System::Sensor::Description* sd_p) {
    *((ABng_Core_System::Sensor::Description*) this) = *sd_p;
  }
  virtual int operator==(const Comparable_Sensor_Descr& sd_p) {
    return item_id == sd_p.item_id;
  }

  static unsigned hash(const Comparable_Sensor_Descr& sd_p);
};

#endif /*  __COMPARABLE_SENSOR_DESCR_H__ */




