// $Id: msp_server.cc,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/msp_server.cc,v $
//
// $Log: msp_server.cc,v $
// Revision 1.1.1.1  1998/06/18 13:37:37  mencnar
//
// Revision 1.1  1998/03/06 13:41:17  jasz
// Initial revision
//
//
// File:          msp_server_i.cc
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  26.01.98
//
// General Description:
//  Definition the MSP server class.

#include <stream.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <errno.h>
#include "msp_server.h"

void MSP_Server::init(int argc, char **argv) {
  
  prog_name = strdup(argv[0]);
  init_corba(argc, argv);

  char c;
  while (( c = getopt (argc, argv, "h")) != -1) {
    switch (c) {
      case 'h': {
	print_info();
	exit(1);
      }
      default: {
	print_info();
	exit(1);
      }
    }
  }
  signal(SIGTERM, signal_handler);
  signal(SIGINT, signal_handler);
  Bootstrap::init(orb_ptr);
  my_msp = new MSP_I();
  set_thread_pool(2);
}

void MSP_Server::final() {

  delete [] prog_name;
  if(my_msp) {
    CORBA::release(my_msp->get_msp_obj());
    delete my_msp;
  }
}

void MSP_Server::print_info() {

  cout << "Usage: " << prog_name << " [options]" << endl << endl;
  cout << "The following options can be used:" << endl;

  cout << "-h \t Print this information." << endl;
}

void MSP_Server::signal_handler(int sig) {

  
  if(!my_instance) {
    return;
  }
  cout << "msp exiting" << endl;
  if(!my_instance->my_msp) {
    return;
  }
  my_instance->final();
}

MSP_Server *MSP_Server::get_instance() {

  if(!my_instance) {
    my_instance = new MSP_Server();
  }
  return my_instance;
}

MSP_Server *MSP_Server::my_instance = 0;
