// $Id: request_mapper.cc,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Log: request_mapper.cc,v $
// Revision 1.1.1.1  1998/06/18 13:37:37  mencnar
//
//
// File:         request_mapper.cc
// Author:       Daniel Mencnarowski (mencnar@ics.agh.edu.pl)
// Date Created: 09.03.98
//
// General Description:
//   Request_Mapper class implementation; keeps track of all issued commands,
//   their request identifiers and corresponding ABng_Core::Caller objects
//

#include "request_mapper.h"

int Request_Record::operator==( const Request_Record &rrec) {
  return (request_id == rrec.request_id);
}


unsigned Request_Record::hash( const Request_Record &rrec) {
  return rrec.request_id;
}

void Request_Mapper::add_request( Request_Record &rrec, 
				  ABng_Core::Caller_var caller_ref) {
  map.insertKeyAndValue( rrec, caller_ref);
}


void Request_Mapper::remove_request( CORBA::Long request_id) {
  Request_Record key( request_id);

  map.remove( key);
}

ABng_Core::Caller_var Request_Mapper::get_caller( CORBA::Long request_id) {
  Request_Record key( request_id);
  ABng_Core::Caller_var ret;

  map.findValue( key, ret);
  return ret;
}

void Request_Mapper::remove_all() {
  map.clear();
}
