// $Id: request_mapper.h,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/request_mapper.h,v $
//

#ifndef __request_mapper_h__
#define __request_mapper_h__

#include "abng_core_management.hh"
#include <rw/tvhdict.h>

class Request_Record {
public:
  CORBA::Long request_id;
  CORBA::Long repeats;
  CORBA::Long retries;
  CORBA::Long repeats_processed;
  CORBA::Long retries_processed;

  Request_Record( CORBA::Long _request_id) : request_id( _request_id) {}
  Request_Record( CORBA::Long _request_id,
		  CORBA::Long _repeats,
		  CORBA::Long _retries,
		  CORBA::Long _repeats_processed,
		  CORBA::Long _retries_processed) :
    request_id( _request_id),
    repeats( _repeats),
    retries( _retries),
    repeats_processed( _repeats_processed),
    retries_processed( _retries_processed) {}

  int operator==( const Request_Record &rrec);
  static unsigned hash( const Request_Record &rrec);
};

class Request_Mapper {
  RWTValHashDictionary< Request_Record, ABng_Core::Caller_var> map;

public:
  Request_Mapper() : map( Request_Record::hash) {}

  void add_request( Request_Record &rrec, ABng_Core::Caller_var caller_ref);
  void remove_request( CORBA::Long request_id);
  ABng_Core::Caller_var get_caller( CORBA::Long request_id);

  void remove_all();
  // please call this method if scheduler was shut down
};

#endif //

//
