//
//  File:         badge_holder_rep_observer_i.cc
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 16.01.98
//
// General Description:
//   Implementation file for the Badge_Holder_Rep_Observer_I class
//
 
#include "badge_holder_rep_observer.h"

   Badge_Holder_Rep_Observer_I::Badge_Holder_Rep_Observer_I (
   )
{
	// init my_corba_object
	my_corba_object = (ABng_Core_System::System_Static_Data_Observer_ptr)NULL;
}

   Badge_Holder_Rep_Observer_I::~Badge_Holder_Rep_Observer_I ()
{
  //	CORBA::release(my_corba_object);
}

 void 
   Badge_Holder_Rep_Observer_I::notify (
	Domain_Repository::Repository_Item_Id id,
	const ABng_Core_System::System_Static_Data_Observer::System_Static_Data_Object& sd, 
	Domain_Repository::Change_Type change,
	CORBA::Environment &IT_env
   )
		throw (CORBA::SystemException)
{
	int id_p;
	Badge_Holder_ptr badge_holder_p;

	switch(change) {
		case Domain_Repository::OBJECT_ADDED:
			cerr << "Badge_Holder_Rep_Observer: new badge_holder added" << endl;	
			badge_holder_p= sd.badge_holder_obj();

			// attempt to get the id of this badge_holder
			try {
				id_p = badge_holder_p->item_id();
			} catch (CORBA::SystemException& se){
				cerr << "Badge_Holder_Rep monitor error: ";
				cerr << "exception when trying to get the id of the new badge_holder! ";
				cerr << endl << &se << endl;
			}
			cerr << "Badge_Holder_Rep_Observer: new badge_holder id " << id_p << endl;

			// attempt to register observer in this badge_holder
			try {
				badge_holder_p->attach_system_static_data_observer(my_corba_object);
			} catch (CORBA::SystemException& se){
				cerr << "Badge_Holder_Rep monitor error: ";
				cerr << "exception when trying to register observer for the new badge_holder! ";
				cerr << endl << &se << endl;
			}
			cerr << "Badge_Holder_Rep monitor: observer for new Badge_Holder registered" << endl;
			break;

		case Domain_Repository::OBJECT_REMOVED:
			cerr << "Badge_Holder_Rep_Observer: badge_holder removed" << endl;	
			break;

		case Domain_Repository::OBJECT_UPDATED:
			cerr << "Badge_Holder_Rep_Observer: badge_holder updated" << endl;	
			badge_holder_p= sd.badge_holder_obj();

			// attempt to get the id of this badge_holder
			try {
				id_p = badge_holder_p->item_id();
			} catch (CORBA::SystemException& se){
				cerr << "Badge_Holder_Rep monitor error: ";
				cerr << "exception when trying to get the id of the updated badge_holder! ";
				cerr << endl << &se << endl;
			}
			cerr << "Badge_Holder_Rep_Observer: updated Badge_Holder id " << id_p << endl;
			break;

		default:
			cerr << "Badge_Holder_Rep_Observer error: unknow change type !!!" << endl;	
	}
}

 void 
   Badge_Holder_Rep_Observer_I::abort (
	CORBA::Environment &IT_env
   ) 
		throw (CORBA::SystemException)
{
	cerr << "Badge_Holder_Rep_Observer: abort called!!!" << endl << endl;	
	cerr << "Badge_Holder_Rep_Observer: exiting!!" << endl;

	exit(0);	

}

