//
//  File:         sensor_rep_observer_i.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 16.12.97
//
// General Description:
//   Header file for the implementation class of the Observer of 
//	the Sensor Repositoryinterface
//

#ifndef badge_rep_observer_i_h
#define badge_rep_observer_i_h

#include <stdio.h>
#include <fstream.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include "abng_core_management.hh"

class Badge_Rep_Observer_I
{
 public:
   // ctor
   Badge_Rep_Observer_I (
   );

  virtual 
   ~Badge_Rep_Observer_I ();

  // reference of CORBA object encapsulated this C++ object
  ABng_Core_System::System_Static_Data_Observer_ptr my_corba_object;

  //
  // IDL operations of the System_Static_Data_Observer interface
  //                       ___________________________
            
  virtual void 
   notify (
	Domain_Repository::Repository_Item_Id item_id,
	const ABng_Core_System::System_Static_Data_Observer::System_Static_Data_Object& sd, 
	Domain_Repository::Change_Type change,
	CORBA::Environment &IT_env=CORBA::default_environment
   )
		throw (CORBA::SystemException);

  virtual void 
   abort (
	CORBA::Environment &IT_env=CORBA::default_environment
   ) 
		throw (CORBA::SystemException);

};   

DEF_TIE_ABng_Core_System_System_Static_Data_Observer(Badge_Rep_Observer_I)

#endif /* badge_rep_observer_i_h */
