// $Id: sched_debug.cc,v 1.2 1998/06/18 14:14:00 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/utils/commander_util/sched_debug.cc,v $
//
// $Log: sched_debug.cc,v $
// Revision 1.2  1998/06/18 14:14:00  mencnar
// moved to CVS
//
// Revision 1.1  1997/10/23 09:42:50  mencnar
// Initial revision
//
//

#include <rw/tvdlist.h>
#include <rw/rwtime.h>
#include <rw/rwdate.h>
#include <rw/cstring.h>
#include "abng_core_management.hh"
#include <iostream.h>
#include <ctype.h>

#include "sched_debug.hh"

/*
ostream & operator << ( ostream &str, 
const 
#ifdef ORBIX
 _IDL_SEQUENCE_octet
#elif defined OMNIORB
 _CORBA_Unbounded_Sequence_Octet 
#endif
&seq) {
  str << "<";
  for (int i=0; i<seq.length(); i++) {
    if (i>0) str << " ";
    str << hex << (int) seq[i];
  }
  str << ">";
  return str;
}

istream & operator >> ( istream &istr, 
#ifdef ORBIX
 _IDL_SEQUENCE_octet
#elif defined OMNIORB
 _CORBA_Unbounded_Sequence_Octet 
#endif
&seq) {
  char c;
  istr >> ws;
  if (istr.peek() != '<') {
    istr.clear( iostream::failbit|istr.rdstate());
    return istr;
  }
  istr >> c;
  if (!istr) return istr;

  istr >> hex;
  RWTValDlist<CORBA::Octet> seq_list;
  do {
    int val;
    istr >> val;
    if (istr) seq_list.append( (CORBA::Octet) val);
  } while (istr);
  istr.clear( iostream::goodbit);
  istr >> ws;
  istr >> c;
  //  cout << "c== " << (int) c << "  " << c << endl;
  if (c != '>') {
    istr.clear( iostream::failbit|istr.rdstate());
    return istr;
  }
  int size= seq_list.entries();
  seq.length( size);

  for (int i=0; i<size; i++)
    seq[i]= seq_list[i];

  istr >> dec;
  return istr;
}
*/

ostream & operator << ( ostream &ostr, const ABng_Core_System::Badge_Ids &seq) {
  ostr << "<";
  for (int i=0; i<seq.length(); i++) {
    if (i>0) ostr << " ";
    ostr << seq[i];
  }
  ostr << ">";
  return ostr;
}

istream & operator >> ( istream &istr, ABng_Core_System::Badge_Ids &seq) {
  char c;
  istr >> ws;
  if (istr.peek() != '<') {
    istr.clear( iostream::failbit|istr.rdstate());
    return istr;
  }
  istr >> c;
  if (!istr) return istr;

  RWTValDlist<ABng_Core_System::Badge_Id> seq_list;

  do {
    ABng_Core_System::Badge_Id val;
    istr >> val;
    if (istr) seq_list.append( val);
  } while (istr);  

  istr.clear( iostream::goodbit);
  istr >> ws;
  istr >> c;
  //  cout << "c== " << (int) c << "  " << c << endl;
  if (c != '>') {
    istr.clear( iostream::failbit|istr.rdstate());
    return istr;
  }
  int size= seq_list.entries();
  seq.length( size);

  for (int i=0; i<size; i++)
    seq[i]= seq_list[i];

  return istr;

}

istream & operator >> ( istream &istr, 
			ABng_Core_System::Sensor_Id &sensor_id) {
  istr >> ws;
  RWCString tmp;

  if (!isxdigit(istr.peek())) {
    istr.clear( iostream::failbit|istr.rdstate());
    return istr;
  }

  istr >> dec;
  istr >> sensor_id.sensor_num;
  istr >> sensor_id.network_num;
  istr >> tmp;
  sensor_id.group_name= tmp;
  return istr;
}

ostream & operator << ( ostream &ostr,
			const ABng_Core_System::Sensor_Id &sensor_id) {
  ostr << dec;
  ostr << "( sensor_num: " << (int) sensor_id.sensor_num
       << " network_num: " << (int) sensor_id.network_num
       << " group_name: " << sensor_id.group_name << " )";
  return ostr;
}

istream & operator >> ( istream &istr,
			ABng_Core_System::Sensor_Ids &seq) {
  char c;
  istr >> ws;
  if (istr.peek() != '<') {
    istr.clear( iostream::failbit|istr.rdstate());
    return istr;
  }
  istr >> c;
  if (!istr) return istr;

  RWTValDlist<ABng_Core_System::Sensor_Id> seq_list;

  do {
    ABng_Core_System::Sensor_Id val;
    istr >> val;
    if (istr) seq_list.append( val);
  } while (istr);  

  istr.clear( iostream::goodbit);
  istr >> ws;
  istr >> c;
  //  cout << "c== " << (int) c << "  " << c << endl;
  if (c != '>') {
    istr.clear( iostream::failbit|istr.rdstate());
    return istr;
  }
  int size= seq_list.entries();
  seq.length( size);

  for (int i=0; i<size; i++)
    seq[i]= seq_list[i];
  
  return istr;
}

ostream & operator << ( ostream &ostr, 
			const ABng_Core_System::Sensor_Ids &seq) {
  ostr << "<";
  for (int i=0; i<seq.length(); i++) {
    if (i>0) ostr << " ";
    ostr << seq[i];
  }
  ostr << ">";
  return ostr;
}

istream & operator >> ( istream &istr,
			ABng_Core::Time &time) {
  return istr >> dec >> time.seconds >> time.microseconds;
}

ostream & operator << ( ostream &ostr, 
			const ABng_Core::Time &time) {

  RWTime offset( RWDate( 1, 1,1970), 0,0,0, RWZone::utc());
  RWTime t( offset.seconds()+time.seconds);
  ostr << t << " " << time.microseconds << " us (local time)";
  return ostr;
}

istream & operator >> ( istream &istr,
			ABng_Core::Command_Context &ctx) {
  RWCString str;

  istr >> dec;
  istr >> ctx.at >> ctx.waiting_for_sighting_timeout 
       >> ctx.waiting_for_reply_timeout >> ctx.retries
       >> ctx.interval >> ctx.repeat >> str;
  if (str == "Error") ctx.interest= ABng_Core::Error;
  else if (str == "Reply") ctx.interest= ABng_Core::Reply;
  else if (str == "Request_Invoked") ctx.interest= ABng_Core::Request_Invoked;
  else if (str == "Error_And_Reply") ctx.interest= ABng_Core::Error_And_Reply;
  else if (str == "Error_And_Request_Invoked") ctx.interest= ABng_Core::Error_And_Request_Invoked;
  else if (str == "None") ctx.interest= ABng_Core::None;
  else 
    istr.clear( iostream::failbit|istr.rdstate());
  return istr; 
}
   
ostream & operator << ( ostream &ostr,
			const ABng_Core::Command_Context &ctx) {
  ostr << dec;
  ostr <<  "( at " << ctx.at 
       << "\n waiting_for_sighting_timeout " << ctx.waiting_for_sighting_timeout.seconds << " s " << ctx.waiting_for_sighting_timeout.microseconds << " us"
       << "\n waiting_for_reply_timeout " << ctx.waiting_for_reply_timeout.seconds << " s " << ctx.waiting_for_reply_timeout.microseconds << " us"
       << "\n retries " << (int) ctx.retries 
       << "\n interval " << ctx.interval.seconds << " s " << ctx.interval.microseconds << " us"
       << "\n repeat " << (int) ctx.repeat
       << "\n ";
  switch ( ctx.interest) {
  case ABng_Core::Error: 
    ostr << "Error"; break;
  case ABng_Core::Reply:
    ostr << "Reply"; break;
  case ABng_Core::Request_Invoked:
    ostr << "Request_Invoked"; break;
  case ABng_Core::Error_And_Reply:
    ostr << "Error_And_Reply"; break;
  case ABng_Core::Error_And_Request_Invoked:
    ostr << "Error_And_Request_Invoked"; break;
  case ABng_Core::None:
    ostr << "None"; break;
  default:
    ostr << "Unknown";
  }
  ostr << "\n)";
  return ostr;
}

ostream & operator << ( ostream &ostr,
			const ABng_Core_System::Scheduler_Request_Queue::Scheduler_Request &dreq) {
  ostr << "(\tuid : " << dreq.uid << endl
       <<  "\trequest_id : " << dreq.request_id << endl
       <<  "\tsensors : " << dreq.sensors << endl
       <<  "\tbadges : " << dreq.badges << endl
       <<  "\targuments : " << dreq.arguments << endl
       <<  "\tcommand_name : " << dreq.command_name << endl
       <<  "\tcommand_context : " << dreq.command_ctx << endl
       <<  "\trequest_time : " << dreq.request_time << " )";
  return ostr;
}


ostream & operator << ( ostream &ostr, 
			const ABng_Core_System::Scheduler_Request_Queue::Scheduler_Requests &seq) {
  ostr << "<";
  for (int i=0; i<seq.length(); i++) {
    ostr << "#" << i << endl;
    ostr << seq[i] << endl;
  }
  ostr << ">";
  return ostr;
}
