#include <stdlib.h>
#include "ldescr_client.h"

extern "C"      int isalpha(int c);
extern "C"      int isdigit(int c);




LDescr_Client::Operations Rep_Client<Location_Description_Types_Mgr>::operations = {{0, {0}}};

char* Rep_Client<Location_Description_Types_Mgr>::description = "\"property_name property_value(appropriate type) property_value(appropriate type) ...\"";

Domain_Repository::Location_Description::Description 
  LDescr_Client::init_data(char* data) {

  Domain_Repository::Location_Description::Description descr;
  
  try {

    location_type_rep->init_rep_ptr();
    cerr << data << endl;    
    char* str = read_string(data);
    Domain_Repository::Location_Type::Pattern ld_pattern=
      location_type_rep->init_pattern();
    ld_pattern.is_any= 0;
    ld_pattern.name_pattern.is_any= 0;
    ld_pattern.name_pattern.value= (const char *) str;
    Domain_Repository::Location_Type::Value_Descriptions_var lts_var= 
      location_type_rep->rep_ptr()->find_values( ld_pattern);

    if (lts_var->length() != 1) {
      cerr << "Type " << str << " not found" << endl;
      exit(1);
    }
    descr.type_name= (const char *) str;
    delete str;

    Domain_Repository::Property_Descriptions &props_descr=
      lts_var[0].property_description_list;
    descr.property_list.length( props_descr.length());
    for(int i = 0; i < props_descr.length(); i ++) {
      descr.property_list[i].name = CORBA::string_dup(props_descr[i].name);
      void * value = read_void(props_descr[i].type, data);
      descr.property_list[i].value.replace(props_descr[i].type, value);
    }
  } catch(...) {
    cerr << "Exception has been thrown" << endl;
    exit(1);
  }
  cerr << "Description created" << endl;
  return descr;
}






