//
//  File:         user_rep_client.h
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 27.05.98
//
// General Description:
//   Header file for the implementation class of a client of 
//	the User Repository interface
//

#ifndef __USER_REP_CLIENT_H__
#define __USER_REP_CLIENT_H__ 1

#include <stream.h>

#include "domain_rep_management.hh"
#include "domain_rep_types_mgr.h"
#include "bootstrap_n.hh"
#include "rep_client.h"

class User_Rep_Client : public Rep_Client<User_Types_Mgr> 
{
public:

   // ctor
   User_Rep_Client() : Rep_Client<User_Types_Mgr> (
	Bootstrap::SRV_User_Repository,
	Bootstrap::SRV_User_Repository_Manager
   ) { }

   virtual 
    ~User_Rep_Client () {}

   virtual Domain_Repository::User::Description
    init_data (
	char* data
    );
};

#endif __USER_REP_CLIENT_H__





