

#include "tevent_data_observer.hh"


#define TEvent_Data_Observer_dispatch_impl

unsigned char TEvent_Data_Observer_dispatch::dispatch (CORBA::Request &IT_r, 
 unsigned char IT_isTarget, void *IT_pp) {
    if (!IT_pp)
       IT_pp = m_obj;
    const char *IT_s = IT_r.getOperation ();
    if (!strcmp(IT_s,"notify")) {
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~notify~>{v},O{}\
"))
            return 1;
        Domain_Repository::Repository_Item_Id id;

        IT_r >> id;

        TEvent_Data_Observer::TEvent_Data_Object sd;

        sd.decodeOp (IT_r);

        Domain_Repository::Change_Type change;

        {
        CORBA::ULong IT_0;
        IT_r >> IT_0;
        change = Domain_Repository::Change_Type(IT_0);
        }

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                ((TEvent_Data_Observer*)IT_pp)->notify (  id,   sd,   change, IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }


        IT_r.replyNoResults (CORBA::Flags(CORBA::INV_NO_RESPONSE),IT_env);


        return 1;
    }

    if (!strcmp(IT_s,"abort")) {
        CORBA::Environment IT_env (IT_r);
        CORBA::Filter* IT_f = CORBA::Orbix.getFilter ();
        if (!IT_r.tcAssert ("\
Ro~abort~>{v},O{}\
"))
            return 1;

        if (IT_f && !IT_r.isException (IT_env))
        	IT_f->inRequestPostM (IT_r, IT_env);
        if (!IT_r.isException (IT_env)) {
            try {
                ((TEvent_Data_Observer*)IT_pp)->abort (IT_env);

            } catch (CORBA::SystemException &IT_exSys) {
            IT_env.propagate (&IT_exSys);
            } catch (CORBA::UserException &IT_exUsr) {
            IT_env.propagate (&IT_exUsr);
            }
        }
        IT_r.replyNoResults (CORBA::Flags(CORBA::INV_NO_RESPONSE),IT_env);
        return 1;
    }

    if (IT_isTarget)
        IT_r.makeRuntimeException2 ();

    return 0;
}

#include "tevent_data_observerC.cc"

