
#include "tevent_rep.hh"

TEvent_Rep_mgr::TEvent_Rep_mgr () 
{
    _ptr = TEvent_Rep:: _nil ();
}

TEvent_Rep_mgr::TEvent_Rep_mgr (const TEvent_Rep_mgr &IT_s) 
{
    _ptr = TEvent_Rep:: _duplicate (IT_s._ptr);
}

TEvent_Rep_mgr::TEvent_Rep_mgr (TEvent_Rep_var IT_s) 
{
    _ptr = TEvent_Rep:: _duplicate (IT_s);
}

TEvent_Rep_mgr::TEvent_Rep_mgr (const TEvent_Rep_SeqElem &IT_s) 
{
    _ptr = TEvent_Rep:: _duplicate (IT_s);
}

TEvent_Rep_mgr &TEvent_Rep_mgr::operator= (TEvent_Rep_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_Rep_mgr &TEvent_Rep_mgr::operator= (const TEvent_Rep_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep:: _duplicate(IT_s._ptr);
    return (*this);
}

TEvent_Rep_mgr &TEvent_Rep_mgr::operator= (TEvent_Rep_var IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep:: _duplicate(IT_s);
    return (*this);
}

TEvent_Rep_mgr &TEvent_Rep_mgr::operator= (const TEvent_Rep_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep:: _duplicate(IT_s);
    return (*this);
}

TEvent_Rep_mgr::~TEvent_Rep_mgr () {
    CORBA::release (_ptr);
}

TEvent_Rep_ptr TEvent_Rep_mgr:: operator-> () const {
    return _ptr;
}

TEvent_Rep_mgr::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_Rep_mgr::operator TEvent_Rep_ptr& () { return (TEvent_Rep_ptr &) (_ptr);}
TEvent_Rep_mgr::operator const TEvent_Rep_ptr& () const { return (TEvent_Rep_ptr &) (_ptr);}

TEvent_Rep_mgr::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_Rep_ptr TEvent_Rep_mgr:: in () const {
    return _ptr;
}

TEvent_Rep_ptr& TEvent_Rep_mgr:: inOut () {
    return _ptr;
}

TEvent_Rep_ptr& TEvent_Rep_mgr:: out () {
    return _ptr;
}

TEvent_Rep_ptr TEvent_Rep_mgr:: ret () const {
    return _ptr;
}

TEvent_Rep_SeqElem::TEvent_Rep_SeqElem (TEvent_Rep_ptr* IT_p, unsigned char rel) {
    _ptr = IT_p;
    _release = rel;
}

TEvent_Rep_SeqElem &TEvent_Rep_SeqElem::operator= (TEvent_Rep_ptr IT_p) {
    if (_ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = IT_p;
    }
    return (*this);
}

TEvent_Rep_SeqElem &TEvent_Rep_SeqElem::operator= (const TEvent_Rep_SeqElem &IT_s) {
    if (_ptr && IT_s._ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Rep:: _duplicate(*(IT_s._ptr));
    }
    return (*this);
}

TEvent_Rep_SeqElem &TEvent_Rep_SeqElem::operator= (const TEvent_Rep_mgr &IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Rep:: _duplicate(IT_s._ptr);
    }
    return (*this);
}

TEvent_Rep_SeqElem &TEvent_Rep_SeqElem::operator= (TEvent_Rep_var IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Rep:: _duplicate (IT_s);
    }
    return (*this);
}

TEvent_Rep_SeqElem::operator ! () const {
    return ((CORBA::is_nil (*_ptr)));
}

TEvent_Rep_SeqElem::operator const TEvent_Rep_ptr& () const { return (TEvent_Rep_ptr &) (*_ptr);}

TEvent_Rep_SeqElem::operator CORBA::Object_ptr () const {
    return *_ptr;
}

TEvent_Rep_ptr TEvent_Rep_SeqElem:: in () const {
    return *_ptr;
}

TEvent_Rep_ptr& TEvent_Rep_SeqElem:: inOut () {
    return *_ptr;
}

TEvent_Rep_ptr& TEvent_Rep_SeqElem:: out () {
    return *_ptr;
}

TEvent_Rep_ptr TEvent_Rep_SeqElem:: ret () const {
    return *_ptr;
}

TEvent_Rep_ptr TEvent_Rep_SeqElem::operator->() const { return *_ptr;}

TEvent_Rep::TEvent_Rep (char *IT_OR) {
      m_pptr = new TEvent_Rep_dispatch (IT_OR, this,(CORBA::Object*)this);
} 
TEvent_Rep::TEvent_Rep (ObjectReferenceImpl *IT_OR) {
      m_pptr = new TEvent_Rep_dispatch (IT_OR, this,(CORBA::Object*)this);
} 

#ifndef TEvent_RepForwC
#define TEvent_RepForwC
CORBA::ObjectRef CALL_SPEC TEvent_Rep_getBase(void *IT_p){
    return (TEvent_Rep*) IT_p;}

void CALL_SPEC TEvent_Rep_release (TEvent_Rep_ptr IT_p, CORBA::Environment &IT_env) {
    CORBA::release(IT_p, IT_env);}

void CALL_SPEC TEvent_Rep_release (TEvent_Rep_ptr IT_p) {
    TEvent_Rep_release (IT_p, CORBA::IT_chooseDefaultEnv ()); }

TEvent_Rep_ptr CALL_SPEC TEvent_Rep_nil (CORBA::Environment &) {
    return TEvent_Rep:: _nil ();}

TEvent_Rep_ptr CALL_SPEC TEvent_Rep_nil () {
    return TEvent_Rep_nil (CORBA::IT_chooseDefaultEnv ());}

TEvent_Rep_ptr CALL_SPEC TEvent_Rep_duplicate (TEvent_Rep_ptr IT_p, CORBA::Environment &IT_env) {
    return (TEvent_Rep::_duplicate(IT_p, IT_env)); }
TEvent_Rep_ptr CALL_SPEC TEvent_Rep_duplicate (TEvent_Rep_ptr IT_p) {
    return TEvent_Rep_duplicate (IT_p, CORBA::IT_chooseDefaultEnv ()); }
#endif

TEvent_Rep_ptr CALL_SPEC TEvent_Rep::_duplicate(TEvent_Rep_ptr obj, CORBA::Environment& IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
       if (!obj) {
          return (obj);
       }
       TEvent_Rep_ptr IT_obj = obj->__duplicate (IT_env);
       return IT_obj;
}



TEvent_Rep* CALL_SPEC TEvent_Rep:: _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env) {
       return (TEvent_Rep*)CORBA::Factory.New (IT_markerServer, IT_env, IT_c, host, 
		TEvent_Rep_IMPL, TEvent_Rep_IR);
}



TEvent_Rep* CALL_SPEC TEvent_Rep:: _bind (CORBA::Environment &IT_env) {
       return _bind (NULL,NULL,CORBA::Context(), IT_env); }


TEvent_Rep* CALL_SPEC TEvent_Rep:: _bind (const char* IT_markerServer, const char* host,
                CORBA::Environment &IT_env) {
       return _bind (IT_markerServer, host, CORBA::Context (), IT_env); }
TEvent_Rep* CALL_SPEC TEvent_Rep::_narrow (CORBA::Object* IT_obj, CORBA::Environment &IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        if (CORBA::is_nil (IT_obj)) {
                return TEvent_Rep:: _nil();
        }

       TEvent_Rep* IT_p = (TEvent_Rep*)CORBA::Object::_castDown (IT_obj, TEvent_Rep_IR, IT_env);
        IT_p = IT_p ? IT_p->__duplicate(IT_env) : NULL;
        if ((IT_env) &&(!strcmp(IT_env.exception()->id(), "CORBA::StExcep::BAD_PARAM")) && (((CORBA::BAD_PARAM*)IT_env.exception())-> minor() == NARROW_FAILED)) {
                IT_env.exception_free();
        }
        return IT_p;
   }

const void* TEvent_Rep:: IT_impl = CORBA::IT_implTable.record (TEvent_Rep_IMPL, "IDL:TEvent_Rep:1.0");

unsigned char TEvent_Rep_var ::copyHelper (const TEvent_Rep_var &IT_s) {
    {
        _ptr = TEvent_Rep:: _duplicate (IT_s._ptr);
    }
    return 1;
}

unsigned char TEvent_Rep_var ::copyHelper (const TEvent_Rep_mgr &IT_s) {
    _ptr = TEvent_Rep:: _duplicate (IT_s._ptr);
return 1;
}

unsigned char TEvent_Rep_var ::copyHelper (const TEvent_Rep_SeqElem &IT_s) {
    _ptr = TEvent_Rep:: _duplicate (IT_s);
return 1;
}

TEvent_Rep_ptr* TEvent_Rep_var ::_newPtr () {
    return new TEvent_Rep_ptr;
}

TEvent_Rep_var ::TEvent_Rep_var (const TEvent_Rep_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Rep_var ::TEvent_Rep_var (const TEvent_Rep_mgr &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Rep_var ::TEvent_Rep_var (const TEvent_Rep_SeqElem &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Rep_var ::TEvent_Rep_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = TEvent_Rep:: _nil ();
}

TEvent_Rep_var ::TEvent_Rep_var (TEvent_Rep_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent_Rep_var &TEvent_Rep_var :: operator= (TEvent_Rep_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_Rep_var &TEvent_Rep_var :: operator= (const TEvent_Rep_var &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_Rep_var &TEvent_Rep_var :: operator= (const TEvent_Rep_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_Rep_var &TEvent_Rep_var :: operator= (const TEvent_Rep_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Rep:: _duplicate (IT_s);
    return (*this);
}

TEvent_Rep_var ::~TEvent_Rep_var () {
    CORBA::release (_ptr);
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent_Rep_ptr TEvent_Rep_var :: operator-> () const {
    return _ptr;
}

TEvent_Rep_var::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_Rep_var::operator TEvent_Rep_ptr& () { return (TEvent_Rep_ptr &) (_ptr);}
TEvent_Rep_var::operator const TEvent_Rep_cptr& () const { return (TEvent_Rep_cptr &) (_ptr);}

TEvent_Rep_var ::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_Rep_ptr TEvent_Rep_var :: in () const {
    return _ptr;
}

TEvent_Rep_ptr& TEvent_Rep_var :: inOut () {
    return _ptr;
}

TEvent_Rep_ptr& TEvent_Rep_var :: out () {
    return _ptr;
}

TEvent_Rep_ptr TEvent_Rep_var :: ret () const {
    return _ptr;
}

void* TEvent_RepProxyFactoryClass::New (char *IT_OR, CORBA::Environment&) {
        return  new class TEvent_Rep(IT_OR);}

void* TEvent_RepProxyFactoryClass::New (ObjectReferenceImpl *IT_OR, CORBA::Environment&) {
        return  new class TEvent_Rep(IT_OR);}

void* TEvent_RepProxyFactoryClass::New2 () {
        return  new class TEvent_Rep((char*)0);}

CORBA::Object* TEvent_RepProxyFactoryClass::NewObject (char *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent_Rep*)New (IT_OR, IT_env));}

CORBA::Object* TEvent_RepProxyFactoryClass::NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent_Rep*)New (IT_OR, IT_env));}

CORBA::Object* TEvent_RepProxyFactoryClass::New2Object () {
        return (CORBA::Object*)((TEvent_Rep*)New2 ());}

void* TEvent_RepProxyFactoryClass::IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env) {
      void *IT_l;
      if (!CORBA::_interfaceCmp (IT_s,TEvent_Rep_IR, IT_env))
         return IT_p;
      else if (IT_l=TEvent_Data_Observed_RProxyFactoryClass::IT_castUp((class TEvent_Data_Observed_R*)((class TEvent_Rep*)IT_p),IT_s, IT_env))
          return IT_l;
      else return NULL;
    }


CORBA::PPTR* TEvent_RepProxyFactoryClass::pptr (void *IT_p) {
       return ((class TEvent_Rep*)IT_p)->_pptr ();}

void TEvent_RepProxyFactoryClass::baseInterfaces (_IDL_SEQUENCE_string& seq) {
      add (seq, TEvent_Rep_IR);
TEvent_Data_Observed_RProxyFactoryClass::baseInterfaces (seq);
}

TEvent_RepProxyFactoryClass TEvent_RepProxyFactory(1);

TEvents* TEvent_Rep:: find (const TEvent::Pattern& data_record_pattern, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return NULL;
    }
    CORBA::Request IT_r (this, "find",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            data_record_pattern.encodeOp (IT_r);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {
                TEvents* IT_result = new TEvents;
                (*(IT_result)).decodeOp (IT_r);
                IT_r.checkEnv (IT_env);
                return IT_result;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {
                TEvents* IT_result = new TEvents;
                (*(IT_result)).decodeOp (IT_r);
                IT_r.checkEnv (IT_env);
                return IT_result;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Search_Not_Implemented        )||!strcmp (IT_str, "Domain_Repository::Search_Not_Implemented"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Search_Not_Implemented;
            ((Domain_Repository::Search_Not_Implemented*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Destination_Unreachable        )||!strcmp (IT_str, "Domain_Repository::Destination_Unreachable"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Destination_Unreachable;
            ((Domain_Repository::Destination_Unreachable*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return NULL;
}

TEvent::Value_Descriptions* TEvent_Rep:: find_values (const TEvent::Pattern& data_record_pattern, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return NULL;
    }
    CORBA::Request IT_r (this, "find_values",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            data_record_pattern.encodeOp (IT_r);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {
                TEvent::Value_Descriptions* IT_result = new TEvent::Value_Descriptions;
                (*(IT_result)).decodeOp (IT_r);
                IT_r.checkEnv (IT_env);
                return IT_result;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {
                TEvent::Value_Descriptions* IT_result = new TEvent::Value_Descriptions;
                (*(IT_result)).decodeOp (IT_r);
                IT_r.checkEnv (IT_env);
                return IT_result;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Search_Not_Implemented        )||!strcmp (IT_str, "Domain_Repository::Search_Not_Implemented"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Search_Not_Implemented;
            ((Domain_Repository::Search_Not_Implemented*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Destination_Unreachable        )||!strcmp (IT_str, "Domain_Repository::Destination_Unreachable"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Destination_Unreachable;
            ((Domain_Repository::Destination_Unreachable*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return NULL;
}

TEvent::Query_Results* TEvent_Rep:: complex_query (const TEvent::Entity_Set& es, const Domain_Repository::Query_Options& qo, TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return NULL;
    }
    CORBA::Request IT_r (this, "complex_query",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            es.encodeOp (IT_r);


            qo.encodeOp (IT_r);


            IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) obs);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {
                TEvent::Query_Results* IT_result = new TEvent::Query_Results;
                (*(IT_result)).decodeOp (IT_r);


                IT_r.checkEnv (IT_env);
                return IT_result;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {


                TEvent::Query_Results* IT_result = new TEvent::Query_Results;
                (*(IT_result)).decodeOp (IT_r);
                IT_r.checkEnv (IT_env);
                return IT_result;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Search_Not_Implemented        )||!strcmp (IT_str, "Domain_Repository::Search_Not_Implemented"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Search_Not_Implemented;
            ((Domain_Repository::Search_Not_Implemented*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }

           else
        if ((!strcmp (IT_str, Domain_Repository::ex_Destination_Unreachable        )||!strcmp (IT_str, "Domain_Repository::Destination_Unreachable"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Destination_Unreachable;
            ((Domain_Repository::Destination_Unreachable*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return NULL;
}





#ifndef TEvent_Rep_dispatch_impl

unsigned char TEvent_Rep_dispatch::dispatch (CORBA::Request &IT_r, 
    unsigned char, void *) {
      IT_r.makeRuntimeException1 ("TEvent_Rep");
      return 0;
}
 
#endif

